# Add project specific ProGuard rules here.
# By default, the flags in this file are appended to flags specified
# in C:\Users\Administrator\AppData\Local\Android\sdk/tools/proguard/proguard-android.txt
# You can edit the include path and order by changing the proguardFiles
# directive in build.gradle.
#
# For more details, see
#   http://developer.android.com/guide/developing/tools/proguard.html

# Add any project specific keep options here:

# If your project uses WebView with JS, uncomment the following
# and specify the fully qualified class name to the JavaScript interface
# class:
#-keepclassmembers class fqcn.of.javascript.interface.for.webview {
#   public *;
#}
-keepclassmembers class * {
   public <init>(org.json.JSONObject);
}
-keep public class cn.liuyanbing.surveyor.R$*{
public static final int *;
}
-keepclassmembers enum * {
    public static **[] values();
    public static ** valueOf(java.lang.String);
}
#混淆前后的映射
-printmapping mapping.txt

-keep class androidx.appcompat.widget.SearchView { *; }
-keep class cn.aigestudio.datepicker.**{*;}

-dontwarn javax.**

-keep class com.tencent.mm.sdk.** {
   *;
}

-dontwarn com.tencent.**
-keep class com.tencent.** {*;}

-ignorewarnings

# Apache POI
-dontwarn org.apache.**
-dontwarn org.openxmlformats.schemas.**
-dontwarn org.etsi.**
-dontwarn org.w3.**
-dontwarn com.microsoft.schemas.**
-dontwarn com.fasterxml.**
-dontwarn javax.naming.**
-dontwarn java.lang.management.**
-dontwarn org.slf4j.impl.**

-dontnote org.apache.**
-dontnote org.openxmlformats.schemas.**
-dontnote org.etsi.**
-dontnote org.w3.**
-dontnote com.microsoft.schemas.**
-dontnote com.fasterxml.**
-dontnote javax.naming.**
-dontnote java.lang.management.**
-dontnote org.slf4j.impl.**

-keeppackagenames org.apache.poi.ss.formula.function

-keep class org.apache.** {*;}
-keep class org.openxmlformats.** {*;}
-keep class org.etsi.** {*;}
-keep class org.w3.** {*;}
-keep class com.microsoft.** {*;}
-keep class com.fasterxml.** {*;}
-keep class schemaorg_apache_xmlbeans.** {*;}

# ------------------------ leancloud sdk ------------------------
-keepattributes Signature
-dontwarn com.jcraft.jzlib.**
-keep class com.jcraft.jzlib.**  { *;}

-dontwarn sun.misc.**
-keep class sun.misc.** { *;}

-dontwarn alibaba.fastjson.**
-dontnote alibaba.fastjson.**
-keep class alibaba.fastjson.** { *;}

-dontwarn sun.security.**
-keep class sun.security.** { *; }

-dontwarn com.google.**
-keep class com.google.** { *;}

-dontwarn com.avos.**
-dontnote com.avos.**
-keep class com.avos.** { *;}

-dontwarn cn.leancloud.**
-dontnote cn.leancloud.**
-keep class cn.leancloud.** { *;}

-keep public class android.net.http.SslError
-keep public class android.webkit.WebViewClient

-dontwarn android.webkit.WebView
-dontwarn android.net.http.SslError
-dontwarn android.webkit.WebViewClient
-dontnote android.net.http.**

-dontwarn android.support.**

-dontwarn org.jivesoftware.smack.**
-keep class org.jivesoftware.smack.** { *;}

-dontwarn com.loopj.**
-keep class com.loopj.** { *;}

-dontwarn com.squareup.okhttp.**
-keep class com.squareup.okhttp.** { *;}
-keep interface com.squareup.okhttp.** { *; }

# keep okhttp3、okio
-dontwarn okhttp3.**
-keep class okhttp3.** { *;}
-keep interface okhttp3.** { *; }
-dontwarn okio.**

-keep class com.google.protobuf.** { *; }
-keep public class * extends com.google.protobuf.** { *; }
-dontwarn com.google.protobuf.**

-dontwarn org.xbill.**
-keep class org.xbill.** { *;}

-keepattributes *Annotation*


# ------------------------ ChatKit ------------------------
-dontwarn cn.leancloud.chatkit.**
-keep class cn.leancloud.chatkit.** { *;}
-dontnote cn.leancloud.chatkit.**

# ------------------------ picasso ------------------------
-dontwarn com.squareup.picasso**
-keep class com.squareup.picasso.**{*;}

# ------------------------ eventbus ------------------------
-keepattributes *Annotation*
-keepclassmembers class * {
    @org.greenrobot.eventbus.Subscribe <methods>;
}
-keep enum org.greenrobot.eventbus.ThreadMode { *; }

# Only required if you use AsyncExecutor
-keepclassmembers class * extends org.greenrobot.eventbus.util.ThrowableFailureEvent {
    <init>(java.lang.Throwable);
}
#--------------------------工具集-----------------------------
-keep class blankj.utilcode.** { *; }
-keepclassmembers class blankj.utilcode.** { *; }
-dontwarn blankj.utilcode.**

-keep class com.chad.library.adapter.** {
*;
}
-keep public class * extends com.chad.library.adapter.base.BaseQuickAdapter
-keep public class * extends com.chad.library.adapter.base.BaseViewHolder
-keepclassmembers  class **$** extends com.chad.library.adapter.base.BaseViewHolder {
     <init>(...);
}

# glide 的混淆代码
-keep public class * implements com.bumptech.glide.module.GlideModule
-keep public enum com.bumptech.glide.load.resource.bitmap.ImageHeaderParser$** {
  **[] $VALUES;
  public *;
}
# banner 的混淆代码
-keep class com.youth.banner.** {
    *;
 }
# 华测sdk
 -keep class com.chc.gnss.sdk.** { *; }
 -dontwarn com.chc.gnss.sdk.**
# 中国移动sdk
 -keep class com.cmcc.sy.hap.** { *; }
 -dontwarn com.cmcc.sy.hap.**
# 梦想CAD sdk
 -keep class org.cocos2dx.** { *; }
 -dontwarn org.cocos2dx.**
 -keep class com.chukong.cocosplay.client.** { *; }
 -dontwarn com.chukong.cocosplay.client.**
 -keep class com.MxDraw.** { *; }
 -dontwarn com.MxDraw.**
#agentweb
 -keep class com.just.agentweb.** {
     *;
 }
 -dontwarn com.just.agentweb.**

#androidx
 -keep class com.google.android.material.** {*;}
 -keep class androidx.** {*;}
 -keep public class * extends androidx.**
 -keep interface androidx.** {*;}
 -dontwarn com.google.android.material.**
 -dontnote com.google.android.material.**
 -dontwarn androidx.**

# 南方坐标转换
 -keep class  com.qxwz.sdk.** { *; }
 -dontwarn  com.qxwz.sdk.**

 -keep class com.bingce.device.rtk.configuration.** { *; }
 -keep class com.bingce.device.rtk.model.** { *; }
 -keep class com.bingce.totalstation.TsConfig { *; }

 #OkSocket
 -dontwarn xuhao.didi.socket.client.**
 -dontwarn xuhao.didi.socket.common.**
 -dontwarn xuhao.didi.socket.server.**
 -dontwarn xuhao.didi.core.**

 -keep class xuhao.didi.socket.client.** { *; }
 -keep class xuhao.didi.socket.common.** { *; }
 -keep class xuhao.didi.socket.server.** { *; }
 -keep class xuhao.didi.core.** { *; }

 -keep class xuhao.didi.socket.client.sdk.client.OkSocketOptions$* {
     *;
 }
 -keep class xuhao.didi.socket.server.impl.OkServerOptions$* {
     *;
 }

 #gsyvideoplayer
 -keep class com.shuyu.gsyvideoplayer.video.** { *; }
 -dontwarn com.shuyu.gsyvideoplayer.video.**
 -keep class com.shuyu.gsyvideoplayer.video.base.** { *; }
 -dontwarn com.shuyu.gsyvideoplayer.video.base.**
 -keep class com.shuyu.gsyvideoplayer.utils.** { *; }
 -dontwarn com.shuyu.gsyvideoplayer.utils.**
 -keep class tv.danmaku.ijk.** { *; }
 -dontwarn tv.danmaku.ijk.**

 -keep public class * extends android.view.View{
     *** get*();
     void set*(***);
     public <init>(android.content.Context);
     public <init>(android.content.Context, android.util.AttributeSet);
     public <init>(android.content.Context, android.util.AttributeSet, int);
 }

# # keep rx
# -dontwarn sun.misc.**
# -keepclassmembers class rx.internal.util.unsafe.*ArrayQueue*Field* {
#  long producerIndex;
#  long consumerIndex;
# }
# -keepclassmembers class rx.internal.util.unsafe.BaseLinkedQueueProducerNodeRef {
#  rx.internal.util.atomic.LinkedQueueNode producerNode;
# }
# -keepclassmembers class rx.internal.util.unsafe.BaseLinkedQueueConsumerNodeRef {
#  rx.internal.util.atomic.LinkedQueueNode consumerNode;
# }
#
# -keep class cn.liuyanbing.surveyor.model.base.SerializableStringArray { *; }

-dontwarn com.yalantis.ucrop**
-keep class com.yalantis.ucrop** { *; }
-keep interface com.yalantis.ucrop** { *; }

-keep class com.bingce.event.WxLoginSuccessEvent{ *; }

# 友盟
 -keep class com.umeng.** {*;}