package com.bingce.controlnetwork.activity;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.Toolbar;

import com.bingce.controlapphelper.util.CheckStorageUtil;
import com.bingce.controlapphelper.util.Tools;
import com.bingce.controlnetwork.R;

import org.polaric.colorful.ColorfulActivity;

import blankj.utilcode.util.ToastUtils;
import blankj.utilcode.util.Utils;

public class AboutActivity extends ColorfulActivity {
    private Toolbar mToolbar;

    @SuppressLint("SourceLockedOrientationActivity")
    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_about);
        mToolbar = findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        final FrameLayout flHolder = findViewById(R.id.activity_about_frame);
        View tianjinView = getTianjinView();
        flHolder.addView(tianjinView);
    }

    @Override
    public boolean onCreateOptionsMenu(@NonNull Menu menu) {
        getMenuInflater().inflate(R.menu.menu_activity_about, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                break;
            case R.id.menu_debug_switch:
                startOpenCloseMeasureDebug();
                break;
        }
        return super.onOptionsItemSelected(item);
    }

    private View getTianjinView() {
        View viewTianjin = View.inflate(this, R.layout.item_about_tj_one, null);
//        TextView tvUnit = viewTianjin.findViewById(R.id.tvUnit);
        TextView tvVersion = viewTianjin.findViewById(R.id.tvVersion);
        tvVersion.setText(Tools.getVersionName());
        return viewTianjin;
    }

    /**
     * 开始打开或关闭调试
     */
    private void startOpenCloseMeasureDebug() {
        CheckStorageUtil.check(this, () -> {
            Utils.isTest = !Utils.isTest;
            if (Utils.isTest) {
                ToastUtils.showShort(R.string.debug_on);
            } else {
                ToastUtils.showShort(R.string.debug_off);
            }
        });
    }

}
