package com.bingce.controlnetwork.activity.backup.launch;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;

import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.Fragment;

public class BackupImportHelper {
    private ICallback callback;
    private final ActivityResultLauncher<Intent> importLauncher;

    public BackupImportHelper(AppCompatActivity activity) {
        importLauncher = activity.registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
            if (callback == null) {
                return;
            }
            boolean success = result != null && Activity.RESULT_OK == result.getResultCode();
            callback.onImported(success);
        });
    }

    public BackupImportHelper(Fragment fragment) {
        importLauncher = fragment.registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
            if (callback == null) {
                return;
            }
            boolean success = result != null && Activity.RESULT_OK == result.getResultCode();
            callback.onImported(success);
        });
    }

    public void doImport(Context context, ICallback callback) {
        this.callback = callback;
        Intent intent = MigrationFolder2PrivateRoomActivity.intent(context, true);
        importLauncher.launch(intent);
    }

    public interface ICallback {
        void onImported(boolean success);
    }
}
