package com.bingce.controlnetwork.activity.fragmentcontainer;

import android.os.Bundle;

import androidx.fragment.app.Fragment;

import com.bingce.controlnetwork.fragment.PickPointFragment;
import com.bingce.controlnetwork.fragment.PointListFragment;
import com.bingce.controlnetwork.fragment.PrismManageFragment;
import com.bingce.controlnetwork.fragment.ProjectToleranceSettingFragment;
import com.bingce.controlnetwork.fragment.SelectExportHeightTraverseFragment;
import com.bingce.controlnetwork.fragment.SelectExportSurveyorRecordFragment;
import com.bingce.controlnetwork.fragment.SelectExportSurveyorRecordWireFileFragment;
import com.bingce.controlnetwork.fragment.SurveyorSettingsFragment;
import com.bingce.controlnetwork.fragment.ToleranceDetailFragment;
import com.bingce.controlnetwork.fragment.ToleranceManageFragment;
import com.bingce.controlnetwork.fragment.ToleranceSelectFragment;
import com.bingce.controlnetwork.fragment.projectdetail.ProjectDetailHeightTraverseFragment;
import com.bingce.controlnetwork.fragment.projectdetail.ProjectDetailTriangleFragment;
import com.bingce.controlnetwork.fragment.station.defaultstation.DefaultStationSetupFragment;
import com.bingce.controlnetwork.fragment.station.heighttraverse.CreateStationForHeightTraverseFragment;
import com.bingce.controlnetwork.fragment.station.line.attached.LineStationAttachedSetupFragment;
import com.bingce.controlnetwork.fragment.station.line.close.LineStationCloseSetupFragment;
import com.bingce.controlnetwork.fragment.station.line.random.LineStationRandomSetupFragment;
import com.bingce.controlnetwork.fragment.station.line.single.LineStationSingleSetupFragment;
import com.bingce.controlnetwork.fragment.station.line.well.LineStationWellDoubleGroundSetupFragment;
import com.bingce.controlnetwork.fragment.station.line.well.LineStationWellDoubleUnderGroundSetupFragment;
import com.bingce.controlnetwork.fragment.station.line.well.LineStationWellSetupFragment;
import com.bingce.controlnetwork.fragment.stationdetail.SingleStationDetailAndEditFragment;
import com.bingce.controlnetwork.fragment.stationsetting.StationSettingHeightTraverseFragment;
import com.bingce.controlnetwork.fragment.stationsetting.StationSettingsFragment;
import com.bingce.controlnetwork.fragment.stationsurvey.StationSurveyorFragment;
import com.bingce.controlnetwork.fragment.stationsurvey.angledistance.MeasureFragment;
import com.bingce.controlnetwork.fragment.stationsurvey.heighttraverse.MeasureHeightTraverseFragment;
import com.bingce.controlnetwork.func.level.fragment.LevelRouteCreateEditFragment;
import com.bingce.controlnetwork.func.level.fragment.LevelSelectExportFragment;
import com.bingce.controlnetwork.func.level.fragment.LevelSurveyFragment;
import com.bingce.controlnetwork.func.level.fragment.ProjectDetailLevelFragment;

import java.util.HashMap;
import java.util.Map;

public class FragmentContainer {
    private interface IBuilder {
        Fragment newInstance(Bundle args);
    }

    private static final Map<String, IBuilder> factory = new HashMap<>();

    static {
        factory.put(ProjectDetailHeightTraverseFragment.TAG, ProjectDetailHeightTraverseFragment::newInstance);
        factory.put(ProjectDetailTriangleFragment.TAG, ProjectDetailTriangleFragment::newInstance);
        factory.put(ProjectToleranceSettingFragment.TAG, ProjectToleranceSettingFragment::newInstance);
        factory.put(ToleranceSelectFragment.TAG, ToleranceSelectFragment::newInstance);
        factory.put(PointListFragment.TAG, PointListFragment::newInstance);
        factory.put(SingleStationDetailAndEditFragment.TAG, SingleStationDetailAndEditFragment::newInstance);
        factory.put(DefaultStationSetupFragment.TAG, DefaultStationSetupFragment::newInstance);
        factory.put(PickPointFragment.TAG, PickPointFragment::newInstance);
        factory.put(StationSurveyorFragment.TAG, StationSurveyorFragment::newInstance);
        factory.put(StationSettingsFragment.TAG, StationSettingsFragment::newInstance);
        factory.put(ToleranceManageFragment.TAG, ToleranceManageFragment::newInstance);
        factory.put(ToleranceDetailFragment.TAG, ToleranceDetailFragment::newInstance);
        factory.put(SelectExportSurveyorRecordFragment.TAG, SelectExportSurveyorRecordFragment::newInstance);
        factory.put(SelectExportSurveyorRecordWireFileFragment.TAG, SelectExportSurveyorRecordWireFileFragment::newInstance);
        factory.put(SurveyorSettingsFragment.TAG, SurveyorSettingsFragment::newInstance);
        factory.put(LineStationSingleSetupFragment.TAG, LineStationSingleSetupFragment::newInstance);
        factory.put(LineStationAttachedSetupFragment.TAG, LineStationAttachedSetupFragment::newInstance);
        factory.put(LineStationCloseSetupFragment.TAG, LineStationCloseSetupFragment::newInstance);
        factory.put(LineStationRandomSetupFragment.TAG, LineStationRandomSetupFragment::newInstance);
        factory.put(LineStationWellSetupFragment.TAG, LineStationWellSetupFragment::newInstance);
        factory.put(LineStationWellDoubleGroundSetupFragment.TAG, LineStationWellDoubleGroundSetupFragment::newInstance);
        factory.put(LineStationWellDoubleUnderGroundSetupFragment.TAG, LineStationWellDoubleUnderGroundSetupFragment::newInstance);
        factory.put(PrismManageFragment.TAG, PrismManageFragment::newInstance);
        factory.put(MeasureFragment.TAG, MeasureFragment::newInstance);
        factory.put(CreateStationForHeightTraverseFragment.TAG, CreateStationForHeightTraverseFragment::newInstance);
        factory.put(MeasureHeightTraverseFragment.TAG, MeasureHeightTraverseFragment::newInstance);
        factory.put(SelectExportHeightTraverseFragment.TAG, SelectExportHeightTraverseFragment::newInstance);
        factory.put(StationSettingHeightTraverseFragment.TAG, StationSettingHeightTraverseFragment::newInstance);
        factory.put(ProjectDetailLevelFragment.TAG, ProjectDetailLevelFragment::newInstance);
        factory.put(LevelSurveyFragment.TAG, LevelSurveyFragment::newInstance);
        factory.put(LevelSelectExportFragment.TAG, LevelSelectExportFragment::newInstance);
        factory.put(LevelRouteCreateEditFragment.TAG, LevelRouteCreateEditFragment::newInstance);
    }

    public static Fragment getFragment(String tag, Bundle bundle) {
        IBuilder builder = factory.get(tag);
        if (builder == null) {
            return null;
        }
        return builder.newInstance(bundle);
    }
}
