package com.bingce.controlnetwork.activity.user;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.widget.Toolbar;

import com.afollestad.materialdialogs.DialogAction;
import com.afollestad.materialdialogs.MaterialDialog;
import com.bingce.controlapphelper.util.SettingValueUtil;
import com.bingce.controlnetwork.App;
import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.util.CheckRegUtil;
import com.bingce.data.sync.utils.LeanCloudConfigLoader;
import com.bingce.device.enums.SpecialDeviceEnum;
import com.bingce.device.ui.dialog.DialogUtil;
import com.bingce.surveyor.agentweb.AgentWebActivity;
import com.bingce.utils.AppUtil;
import com.bingce.utils.ClipboardUtils;
import com.bingce.utils.PropertiesGet;
import com.bingce.utils.RegisterUtil;
import com.bingce.utils.SdkUtils;
import com.bingce.utils.StringUtil;
import com.bingce.utils.Util;
import com.hjq.permissions.OnPermissionCallback;
import com.hjq.permissions.Permission;
import com.hjq.permissions.XXPermissions;
import com.huawei.hms.hmsscankit.ScanUtil;
import com.huawei.hms.hmsscankit.WriterException;
import com.huawei.hms.ml.scan.HmsBuildBitmapOption;
import com.huawei.hms.ml.scan.HmsScan;
import com.rengwuxian.materialedittext.MaterialEditText;

import org.polaric.colorful.ColorfulActivity;

import java.util.List;
import java.util.Locale;

import blankj.utilcode.util.AppUtils;
import blankj.utilcode.util.ToastUtils;
import blankj.utilcode.util.Utils;

public class RegisterActivity extends ColorfulActivity {
    private MaterialEditText met_machine_code, met_activate_code;
    private Button mBtnCopy, mBtnActivate, mBtnTaobaoLink, mBtnContactAuthor, mBtnMachineQr, mBtnActivateTutorial;
    private TextView mTextViewActivity, mTextViewVersion;
    private String mMachineCode = "", mOriginalMachineCode = "";
    private Toolbar mToolbar;
    boolean hasAndroidPermission = false;
    private ProgressDialog progressDialog;
    private ImageView qrImageView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_activate);
        mToolbar = findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        initWidget();
        initMaterialEditTextColor();

        mTextViewVersion.setText("V" + AppUtils.getAppVersionName());

        if (!AppUtil.isZhCN() && SdkUtils.isRegCodeValidate() && !SdkUtils.isIntlCodeValidate()) {//非中文环境需要国际许可码
            DialogUtil.mDismissAlertDialog(this, R.string.hint, R.string.you_need_apply_for_an_international_license_code, R.string.i_know, null, null);
        }

        boolean isSpecial = false;
        for (SpecialDeviceEnum device : SpecialDeviceEnum.values()) {
            if (device.getModel().equals(PropertiesGet.getModel())
                    && device.getDevice().equals(PropertiesGet.getDevice())
                    && device.getBoard().equals(PropertiesGet.getBoard())
                    && device.getBrand().equals(PropertiesGet.getBrand())
                    && device.getCpuAbi().equals(PropertiesGet.getCpuAbi())
                    && device.getHardware().equals(PropertiesGet.getHardware())
                    && device.getManufacturer().equals(PropertiesGet.getManufacturer())) {
                isSpecial = true;
                break;
            }
        }
//        if (!isSpecial && Build.VERSION.SDK_INT >= 29) {
//            mBtnTaobaoLink.setVisibility(View.GONE);
//            new AlertDialog.Builder(this)
//                    .setMessage("由于安卓10及以上系统限制App读取硬件信息，原来绑定手机激活的方式已经不可用，如果您之前绑定手机激活过，很遗憾，现在只能刷机降级到安卓9或安卓8重新输入激活才可以。如果您不想刷机，可以购买会员继续使用")
//                    .setPositiveButton(R.string.user_vip_activate, new DialogInterface.OnClickListener() {
//                        @Override
//                        public void onClick(DialogInterface dialog, int which) {
//                            if (LCUser.getCurrentUser() == null) {
//                                Intent intent = new Intent(Utils.getApp(), LoginActivity.class);
//                                intent.putExtra("finishTo", UserInfoActivity.class.getName());
//                                startActivity(intent);
//                            } else {
//                                startActivity(new Intent(RegisterActivity.this, UserInfoActivity.class));
//                            }
//                        }
//                    })
//                    .setNeutralButton(R.string.opening_vip_tutorial, new DialogInterface.OnClickListener() {
//                        @Override
//                        public void onClick(DialogInterface dialog, int which) {
////                            Intent intent = new Intent();
////                            intent.setClass(Utils.getApp(), AgentWebActivity.class);
////                            intent.putExtra("short_url", "android_url_opening_renewal_tutorial");
////                            startActivity(intent);
//                            AgentWebActivity.navigation2(RegisterActivity.this,
//                                    "android_url_opening_renewal_tutorial");
//                        }
//                    })
//                    .setNegativeButton(R.string.cancel, null)
//                    .setOnDismissListener(new DialogInterface.OnDismissListener() {
//                        @Override
//                        public void onDismiss(DialogInterface dialog) {
//                            if (!hasAndroidPermission)
//                                finish();
//                        }
//                    }).show();
//        } else {
//            int checkStoragePermission = ContextCompat.checkSelfPermission(Utils.getApp(), Manifest.permission.READ_PHONE_STATE);
//            if (checkStoragePermission != PackageManager.PERMISSION_GRANTED) {
//                requestPhoneStatePermission(this);
//            } else {
//                if ("".equals(RegisterUtil.getOriginalMachineCode()) || "SERIALNUMBERunknown".equals(RegisterUtil.getOriginalMachineCode()) || "SERIALNUMBERnull".equals(RegisterUtil.getOriginalMachineCode())) {
//                    new MaterialDialog.Builder(this)
//                            .title(R.string.hint)
//                            .content("此手机机器码未知，请关闭相关限制软件请重启软件")
//                            .positiveText(R.string.i_know)
//                            .dismissListener(new DialogInterface.OnDismissListener() {
//                                @Override
//                                public void onDismiss(DialogInterface dialog) {
//                                    finish();
//                                }
//                            }).show();
//                }
//            }
//        }
        if (CheckRegUtil.checkReg(((App) Utils.getApp()).registerCodeV2)) {
            getSupportActionBar().setTitle(R.string.activated);
            met_activate_code.setText(((App) Utils.getApp()).registerCodeV2);
            mBtnActivate.setEnabled(false);
            met_activate_code.setEnabled(false);
            mBtnActivate.setText(R.string.activated);
        }

        mMachineCode = RegisterUtil.getEncryptMachineCodeInfo();
        mOriginalMachineCode = RegisterUtil.getOriginalMachineCode();
        if (mMachineCode != null) {
            met_machine_code.setText(mMachineCode);
        } else {
            met_machine_code.setText(getString(R.string.get_machine_code_fail));
        }
        String queryUrl = "activate_activity_for_control_network";
        LeanCloudConfigLoader.findInBackground(queryUrl, instance -> {
//        new LCQuery<>("Configuration")
//                .whereEqualTo("name", queryUrl)
//                .limit(1)
//                .findInBackground()
//                .subscribe(new Observer<List<LCObject>>() {
//                    @Override
//                    public void onSubscribe(Disposable d) {
//
//                    }
//
//                    @Override
//                    public void onNext(List<LCObject> avObjects) {
            if (isFinishing()) return;
            if (/*avObjects != null && !avObjects.isEmpty() && avObjects.get(0).getString("value") != null*/instance != null && StringUtil.isNotEmpty(instance.value)) {
                String activity = /*avObjects.get(0).getString("value")*/instance.value;
                mTextViewActivity.setText(activity);
            }
//                    }
//
//                    @Override
//                    public void onError(Throwable e) {
//
//                    }
//
//                    @Override
//                    public void onComplete() {
//
//                    }
        });
        mBtnCopy.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                if (mMachineCode != null) {
                    ClipboardUtils.copyText(mMachineCode);
                    ToastUtils.showShort(R.string.has_copy_to_clipboard);
                } else {
                    ToastUtils.showShort(R.string.get_machine_code_fail);
                }
            }
        });
        mBtnActivate.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                final String registerCode = met_activate_code.getText().toString().trim().toUpperCase(Locale.CHINA).replaceAll(" |\n|\r", "");
                if (mMachineCode == null) {
                    ToastUtils.showShort(R.string.machine_code_illegal);
                    return;
                }
                if ("".equals(met_activate_code.getText().toString().trim())) {
                    ToastUtils.showShort(R.string.please_input_register_code);
                    return;
                }
                if (registerCode.length() != 16) {
                    ToastUtils.showShort(R.string.register_code_is_16_characters);
                    return;
                }

                progressDialog = new ProgressDialog(RegisterActivity.this);
                progressDialog.setMessage(getString(R.string.please_wait));
                progressDialog.setCanceledOnTouchOutside(false);
                progressDialog.show();

                if (CheckRegUtil.checkReg(registerCode)) {
                    ((App) Utils.getApp()).registerCodeV2 = registerCode;
                    Util.putPreference("registerCodeV2", registerCode);

                    getSupportActionBar().setTitle(R.string.activated);
                    mBtnActivate.setEnabled(false);
                    met_activate_code.setEnabled(false);

                    getSupportActionBar().setTitle(R.string.activated);
                    mBtnActivate.setEnabled(false);
                    met_activate_code.setEnabled(false);
                    mBtnActivate.setText(R.string.activated);

                    ToastUtils.showShort(R.string.activate_success);

                    progressDialog.dismiss();
                } else {
                    ToastUtils.showShort("激活失败，请联系管理员");
                    progressDialog.dismiss();
                }

            }
        });
        mBtnTaobaoLink.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
//                Intent intent = new Intent();
//                intent.setClass(Utils.getApp(), AgentWebActivity.class);
//                intent.putExtra("short_url", "taobaoUrl");
//                startActivity(intent);
                AgentWebActivity.navigation2(RegisterActivity.this, "taobaoUrl");
            }
        });
        mBtnContactAuthor.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
//                Intent intent = new Intent();
//                intent.setClass(Utils.getApp(), AgentWebActivity.class);
//                intent.putExtra("short_url", "android_url_contact_author");
//                startActivity(intent);
                AgentWebActivity.navigation2(RegisterActivity.this,
                        "android_url_contact_author");
            }
        });

        mBtnMachineQr.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                if (!mMachineCode.isEmpty())
                    showMachineCodeQr(mMachineCode);
            }
        });

        mBtnActivateTutorial.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
//                Intent intent = new Intent();
//                intent.setClass(Utils.getApp(), AgentWebActivity.class);
//                intent.putExtra("short_url", "android_url_activate_tutorial");
//                startActivity(intent);
                AgentWebActivity.navigation2(
                        RegisterActivity.this,
                        "android_url_activate_tutorial");
            }
        });
    }

    private void initWidget() {
        met_machine_code = findViewById(R.id.activity_activate_met_machine_code);
        met_activate_code = findViewById(R.id.activity_activate_met_activate_code);
        mBtnCopy = findViewById(R.id.activity_activate_btn_copy);
        mBtnActivate = findViewById(R.id.activity_activate_btn_activate);
        mBtnTaobaoLink = findViewById(R.id.activity_activate_btn_taobao_link);
        mBtnContactAuthor = findViewById(R.id.activity_activate_btn_contact_customer_service);
        mBtnMachineQr = findViewById(R.id.activity_activate_btn_machine_code_qr_code);
        mBtnActivateTutorial = findViewById(R.id.activity_activate_btn_activate_tutorial);
        mTextViewActivity = findViewById(R.id.activity_activate_tv_activity);
        mTextViewVersion = findViewById(R.id.activity_activate_tv_version);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId() == android.R.id.home) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 12) {
            if (resultCode == Activity.RESULT_OK) {
                met_activate_code.setText(((App) Utils.getApp()).registerCodeV2);
                getSupportActionBar().setTitle(R.string.activated);
                mBtnActivate.setEnabled(false);
                met_activate_code.setEnabled(false);
            }
        }
    }

    private void initMaterialEditTextColor() {
        if (SettingValueUtil.isThemeDark()) {
            met_machine_code.setMetTextColor(Color.WHITE);
            met_activate_code.setMetTextColor(Color.WHITE);

            met_machine_code.setPrimaryColor(Color.LTGRAY);
            met_activate_code.setPrimaryColor(Color.LTGRAY);

            met_machine_code.setFocusFraction(1.0f);
            met_activate_code.setFocusFraction(1.0f);

            met_machine_code.setMetHintTextColor(Color.GRAY);
            met_activate_code.setMetHintTextColor(Color.GRAY);

            met_machine_code.setUnderlineColor(Color.GRAY);
            met_activate_code.setUnderlineColor(Color.GRAY);
        }
    }

    /**
     * 生成机器码的二维码
     */
    public void showMachineCodeQr(String mMachineCode) {
        MaterialDialog dialog = new MaterialDialog.Builder(this)
                .title(R.string.machine_code)
                .customView(R.layout.dialog_machine_code_qr_code, false)
                .positiveText(this.getString(R.string.close))
                .build();

        qrImageView = dialog.getCustomView().findViewById(R.id.dialog_machine_code_qr_code_imageview);
        try {
            HmsBuildBitmapOption options = new HmsBuildBitmapOption.Creator()
                    .setBitmapMargin(1)
                    .setBitmapColor(Color.BLACK)
                    .setBitmapBackgroundColor(Color.WHITE)
                    .create();
            Bitmap resultImage = ScanUtil.buildBitmap(mMachineCode, HmsScan.QRCODE_SCAN_TYPE, 700, 700, options);
            qrImageView.setImageBitmap(resultImage);
        } catch (WriterException e) {
            ToastUtils.showShort("二维码参数错误!");
        }
        dialog.show();
    }

    public static void requestPhoneStatePermission(Context context) {
        new MaterialDialog.Builder(context)
                .title(R.string.mobile_phone_permissions)
                .content(R.string.verify_imei_imsi_code_to_prevent_account_theft)
                .canceledOnTouchOutside(false)
                .positiveText(R.string.to_allow)
                .negativeText(R.string.refuse)
                .onPositive(new MaterialDialog.SingleButtonCallback() {
                    @Override
                    public void onClick(@NonNull MaterialDialog dialog, @NonNull DialogAction which) {
                        XXPermissions.with(context)
                                .permission(Permission.READ_PHONE_STATE)
                                .request(new OnPermissionCallback() {
                                    @Override
                                    public void onGranted(List<String> permissions, boolean all) {
                                    }

                                    @Override
                                    public void onDenied(List<String> permissions, boolean never) {
                                        if (never) {
                                            ToastUtils.showShort(R.string.manually_enable_the_phone_state_permission_to_bind_hardware_devices);
                                        } else {
                                            ToastUtils.showShort(R.string.please_open_permission_to_activation);
                                            requestPhoneStatePermission(context);
                                        }
                                    }
                                });
                    }
                })
                .show();
    }
}
