package com.bingce.controlnetwork.adapter;

import android.content.Context;

import com.bingce.controlapphelper.datasource.database.point.PointRecord;
import com.bingce.controlapphelper.model.PickPointResult;
import com.bingce.controlnetwork.R;

import java.util.List;

/*
 * 限差详情adapter
 * */
public class GlobalControlPointSelectAdapter extends AbstractPointSelectAdapter {
    private final List<PointRecord> pointRecordList;

    public GlobalControlPointSelectAdapter(List<PointRecord> pointRecords,
                                           PickPointResult defaultValue,
                                           int maxCount,//boolean singlePick,
                                           Context context) {
        super(defaultValue, maxCount, context);
        this.pointRecordList = pointRecords;
    }

    @Override
    public int getGroupCount() {
        return 1;
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        return pointRecordList.size();
    }

    @Override
    public String getGroup(int groupPosition) {
        return context().getString(R.string.global_control_point);
    }

    @Override
    public PointRecord getChild(int groupPosition, int childPosition) {
        return pointRecordList.get(childPosition);
    }

    @Override
    protected boolean showGroupArrow() {
        return false;
    }
}