package com.bingce.controlnetwork.adapter;

import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;

import com.bingce.controlapphelper.model.UniversalListItem;
import com.bingce.controlapphelper.model.ViewItemType;

import java.util.List;

import com.bingce.controlnetwork.ui.vh.IndexTextSelectableViewHolder;
import com.bingce.controlnetwork.ui.widget.ViewFactory;

public class ReSurveyorCycleAdapter extends BaseAdapter<UniversalListItem<String>, IndexTextSelectableViewHolder> {

    private final List<UniversalListItem<String>> dataList;
    private final ICallBack callBack;

    private int selectPosition = -1;

    public ReSurveyorCycleAdapter(List<UniversalListItem<String>> dataList, ICallBack callBack) {
        super(dataList);
        this.dataList = dataList;
        this.callBack = callBack;
    }

    @Override
    protected IndexTextSelectableViewHolder createVH(@NonNull ViewGroup parent, int viewType) {
        return (IndexTextSelectableViewHolder) ViewFactory.generatorViewHolder(parent.getContext(), parent, ViewItemType.indexWithNameSelectable);
    }

    @Override
    public void onBindViewHolder(@NonNull IndexTextSelectableViewHolder holder, int position) {
        holder.index.setVisibility(View.GONE);
        holder.name.setText(dataList.get(position).getName());

        if (position == selectPosition) {
            holder.status.setVisibility(View.VISIBLE);
        } else {
            holder.status.setVisibility(View.GONE);
        }

        holder.itemView.setOnClickListener(v -> {
            selectPosition = holder.getAbsoluteAdapterPosition();
            notifyItemRangeChanged(0, dataList.size());
            callBack.back(selectPosition);
        });
    }

    public interface ICallBack {
        void back(int cycleIndex);
    }

}
