package com.bingce.controlnetwork.adapter;

import android.content.Context;

import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.bingce.controlapphelper.model.UniversalListItem;
import com.bingce.controlapphelper.model.ViewItemType;

import java.util.List;

import blankj.utilcode.util.ToastUtils;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.fragment.TipsFragment;

public class ResurveyorPointsAdapter extends MultipleSelectableIndexWithTextAdapter<ResurveyorPointsAdapter.Item> {
    private final FragmentManager fragmentManager;
    private final LifecycleOwner lifecycleOwner;
    private final Context context;

    public ResurveyorPointsAdapter(List<String> selectedIds,
                                   List<Item> items,
                                   Context context,
                                   FragmentManager fragmentManager,
                                   LifecycleOwner lifecycleOwner) {
        super(selectedIds, items, null);
        this.fragmentManager = fragmentManager;
        this.lifecycleOwner = lifecycleOwner;
        this.context = context;
    }

    @Override
    protected void onItemClicked(String id) {
        //判断上限数据
        if (!selectedIds().contains(id)) {
            if (selectedIds().size() + 1 > getItemCount() / 3) {
                TipsFragment.tipsOnly(fragmentManager, lifecycleOwner, context,
                        context.getString(R.string.tips_resurveyor_count_exceed_1_3));
                return;
            }
        }
        if (getItem(0) != null && getItem(0).getId().equals(id)) {
            ToastUtils.showShort(R.string.tips_resurveyor_must_select_0_point);
            return;
        }
        super.onItemClicked(id);
    }

    public static class Item extends UniversalListItem<String> {
        public Item(String name, String id) {
            super(name, id, null);
        }

        @Override
        public ViewItemType getType() {
            return null;
        }
    }
}
