package com.bingce.controlnetwork.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

import com.bingce.controlnetwork.R;

public class SpinnerAdapter extends BaseAdapter {

    private final Context context;

    private final List<String> lists;


    public SpinnerAdapter(Context context, List<String> list) {
        this.context = context;
        this.lists = new ArrayList<>();
        lists.addAll(list);
    }

    @Override
    public int getCount() {
        return lists.size();
    }

    @Override
    public String getItem(int position) {
        return lists.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        convertView = getConvertView(convertView, parent);
        ViewHodler viewHodler = (ViewHodler) convertView.getTag();
        viewHodler.textView.setText(getItem(position));
        return convertView;
    }

    @Override
    public View getDropDownView(int position, View convertView, ViewGroup parent) {
        convertView = getConvertView(convertView, parent);
        ViewHodler viewHodler = (ViewHodler) convertView.getTag();
        viewHodler.imageView.setVisibility(position == 0 ? View.VISIBLE : View.GONE);
        viewHodler.textView.setText(getItem(position));
        return convertView;
    }


    private View getConvertView(View convertView, ViewGroup parent) {
        if (convertView == null) {
            ViewHodler viewHodler = new ViewHodler();
            convertView = LayoutInflater.from(context).inflate(R.layout.item_spinner_content, parent, false);
            viewHodler.textView = convertView.findViewById(R.id.tv);
            viewHodler.imageView = convertView.findViewById(R.id.ivArrow);
            convertView.setTag(viewHodler);
        }
        return convertView;
    }

    private class ViewHodler {
        public TextView textView;
        public ImageView imageView;
    }

    public void setLists(List<String> lists) {
        this.lists.clear();
        this.lists.addAll(lists);
        notifyDataSetChanged();
    }
}
