package com.bingce.controlnetwork.adapter.contextmenu;

import android.view.MenuItem;

import com.bingce.controlnetwork.R;

public abstract class ContextMenuDeleteEdit<T> implements IAdapterContextMenu<T> {
    @Override
    final public int menuItemSize() {
        return 2;
    }

    @Override
    final public int menuItemName(int index) {
        if (index == 0) {
            return R.string.menu_delete;
        }
        return R.string.menu_edit;
    }

    @Override
    final public boolean onMenuItemClick(T item, MenuItem menuItem) {
        if (menuItem.getItemId() == 0) {
            delete(item);
            return true;
        }
        if (menuItem.getItemId() == 1) {
            edit(item);
            return true;
        }
        return false;
    }

    protected abstract void delete(T item);

    protected abstract void edit(T item);
}
