package com.bingce.controlnetwork.adapter.contextmenu;

import android.content.Context;

import androidx.annotation.NonNull;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.bingce.controlapphelper.ProjectHelper;
import com.bingce.controlapphelper.datasource.database.project.ProjectRecord;
import com.bingce.controlapphelper.util.IUIRunner;

import com.bingce.controlnetwork.fragment.projectedit.AbstractProjectEditFragment;

public class ProjectAdapterContextMenu extends ContextMenuDeleteEdit<ProjectRecord> {
    private @NonNull
    final FragmentManager fragmentManager;
    private @NonNull
    final Context context;
    private final @NonNull
    IUIRunner iuiRunner;
    private final @NonNull
    LifecycleOwner lifecycleOwner;

    private final ProjectHelper projectHelper;

    public ProjectAdapterContextMenu(
            @NonNull Context context,
            @NonNull IUIRunner iuiRunner,
            @NonNull LifecycleOwner lifecycleOwner,
            @NonNull FragmentManager fragmentManager) {
        this.fragmentManager = fragmentManager;
        this.context = context;
        this.iuiRunner = iuiRunner;
        this.lifecycleOwner = lifecycleOwner;
        projectHelper = new ProjectHelper(lifecycleOwner.getLifecycle());
    }

    @Override
    protected void delete(ProjectRecord item) {
        projectHelper.deleteProject(fragmentManager, lifecycleOwner, context, item);
    }

    @Override
    protected void edit(ProjectRecord item) {
        AbstractProjectEditFragment.editProject(fragmentManager, context, item.getId(), item.getProjectTypeFault(),
                item.getToleranceId(), item.getProjectName());
    }
}