package com.bingce.controlnetwork.fragment;

import android.graphics.Color;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.bingce.controlapphelper.util.SettingValueUtil;
import com.wedcel.dragexpandgrid.model.DargChildInfo;
import com.wedcel.dragexpandgrid.model.DragIconInfo;
import com.wedcel.dragexpandgrid.view.CustomAboveView;
import com.wedcel.dragexpandgrid.view.CustomGroup;

import java.util.ArrayList;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.ui.widget.NoScrollView;
import com.bingce.controlnetwork.util.config.ConfigsSetConfigs;

/**
 * 主页面-管理
 */
public class ConfigFragment extends Fragment {
    private CustomGroup mCustomGroup;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_config, container, false);
        mCustomGroup = rootView.findViewById(R.id.fragment_config_custom_group);
        NoScrollView mScrollView = rootView.findViewById(R.id.fragment_config_custom_group_scrollview);

        if (SettingValueUtil.isThemeDark()) {
            mScrollView.setBackgroundColor(Color.DKGRAY);
            mCustomGroup.setNameTextColor(Color.WHITE);
        }
        return rootView;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        mCustomGroup.setHasMoreIcon(false);

        ArrayList<DragIconInfo> iconInfoList = new ArrayList<>();
        ConfigsSetConfigs.getInstance().foreach(item -> iconInfoList.add(
                new DragIconInfo(
                        item.getId(),
                        getString(item.getTitle()),
                        item.getIcon(),
                        item.getCategory(),
                        false,
                        new ArrayList<>())));
        mCustomGroup.initIconInfo(iconInfoList);

        mCustomGroup.setCustomViewClickListener(new CustomAboveView.CustomAboveViewClickListener() {
            @Override
            public void onSingleClicked(DragIconInfo iconInfo) {
                if (iconInfo == null) {
                    return;
                }
                ConfigsSetConfigs.getInstance().onItemClick(iconInfo.getId(), ConfigFragment.this);
            }

            @Override
            public void onChildClicked(DargChildInfo childInfo) {
            }
        });
//        mCustomGroup.setEditModelListener(new CustomGroup.InfoEditModelListener() {
//            @Override
//            public void onModelChanged(boolean isEditModel) {
//                if (getActivity() instanceof MainActivity) {
////                    ((MainActivity) getActivity()).getViewPager().setNoScroll(isEditModel);
//                }
//                mScrollView.setNoScroll(isEditModel);
//            }
//        });
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

    }

    public CustomGroup getCustomGroup() {
        return mCustomGroup;
    }
}
