package com.bingce.controlnetwork.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.google.android.material.bottomsheet.BottomSheetDialogFragment;

import com.bingce.controlnetwork.R;

/**
 * 选择二井定向-地上还是地下
 */
public class SelectSurveyorStationTypeWellSubFragment extends BottomSheetDialogFragment {
    public static final String TAG = SelectProjectAndSurveyorCycleFragment.class.getName();

    private SelectSurveyorStationTypeWellSubFragment() {
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater
                .inflate(
                        R.layout.fragment_bottom_popup_surveyor_station_type_select_layout_well_sub,
                        container,
                        false);
        View.OnClickListener onClickListener = v -> {
            if (v == null) {
                dismiss();
                return;
            }
            int id = v.getId();
            String type = TYPE_GROUND;
            if (id == R.id.wire_ground) {
                type = TYPE_GROUND;
            } else if (id == R.id.wire_underground) {
                type = TYPE_UNDERGROUND;
            }
            Bundle args = new Bundle();
            args.putString(KEY_TYPE, type);
            getParentFragmentManager().setFragmentResult(KEY_REQUEST_SELECT, args);
            dismiss();
        };

        setOnClickListener(view, R.id.wire_ground, onClickListener);
        setOnClickListener(view, R.id.wire_underground, onClickListener);
        setOnClickListener(view, R.id.cancel, v -> dismiss());

        return view;
    }

    private static void setOnClickListener(View root, int id, View.OnClickListener onClickListener) {
        View view = root.findViewById(id);
        if (view != null) {
            view.setOnClickListener(onClickListener);
        }
    }

    private static final String KEY_REQUEST_SELECT = "__SELECT__";
    private static final String KEY_TYPE = "__SELECT_TYPE__";

    public static final String TYPE_GROUND = "type_ground";//二井定向地上
    public static final String TYPE_UNDERGROUND = "type_underground";//二井定向地下

    public static void select(FragmentManager fragmentManager,
                              @NonNull LifecycleOwner lifecycleOwner,
                              IOnSelectCallback callback) {
        SelectSurveyorStationTypeWellSubFragment fragment = new SelectSurveyorStationTypeWellSubFragment();
        fragmentManager
                .setFragmentResultListener(
                        KEY_REQUEST_SELECT,
                        lifecycleOwner,
                        (requestKey, result) -> {
                            if (KEY_REQUEST_SELECT.equals(requestKey)) {
                                callback.onSurveyorCycleSelected(result.getString(KEY_TYPE));
                            }
                        });
        fragment.show(fragmentManager, TAG);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if (getDialog() == null) {
            return;
        }
        getDialog().getWindow().setLayout(
                WindowManager.LayoutParams.MATCH_PARENT,
                WindowManager.LayoutParams.WRAP_CONTENT);
    }

    public interface IOnSelectCallback {
        void onSurveyorCycleSelected(String type);
    }
}