package com.bingce.controlnetwork.fragment;

import android.os.Bundle;
import android.view.View;
import android.webkit.JavascriptInterface;

import androidx.annotation.Nullable;

import com.bingce.data.sync.utils.LeanCloudConfigLoader;
import com.bingce.surveyor.agentweb.AgentWebFragment;
import com.bingce.surveyor.agentweb.FragmentKeyDown;
import com.bingce.surveyor.agentweb.sonic.SonicImpl;
import com.bingce.surveyor.constant.ServicePageUrl;
import com.bingce.utils.StringUtil;
import com.just.agentweb.MiddlewareWebClientBase;


/**
 * 主页面-服务
 */
public class ServiceFragment extends AgentWebFragment implements FragmentKeyDown {
    public static final String TAG = "ServiceFragment";
    public final String offlineUrl = "file:///android_asset/service_default.html";
    private SonicImpl mSonicImpl;

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        // 1. 首先创建SonicImpl
        mSonicImpl = new SonicImpl(offlineUrl, this.getContext());
        // 2. 调用 onCreateSession
        mSonicImpl.onCreateSession();
        //3. 创建AgentWeb ，注意创建AgentWeb的时候应该使用加入SonicWebViewClient中间件
        super.onViewCreated(view, savedInstanceState); // 创建 AgentWeb 注意的 go("") 传入的 mUrl 应该null 或者""
        //4. 注入 JavaScriptInterface
        if (mAgentWeb != null) {
            //注入对象
            mAgentWeb.getJsInterfaceHolder().addJavaObject("android", this);
        }
        //5. 最后绑定AgentWeb
        mSonicImpl.bindAgentWeb(mAgentWeb);

        refresh();
    }

    //在步骤3的时候应该传入给AgentWeb
    @Override
    public MiddlewareWebClientBase getMiddlewareWebClient() {
        return mSonicImpl.createSonicClientMiddleWare();
    }

    //getUrl 应该为null
    @Override
    public String getUrl() {
        return null;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        //销毁SonicSession
        if (mSonicImpl != null) {
            mSonicImpl.destrory();
        }
    }

    @JavascriptInterface
    public void refresh() {
        String queryUrl = "android_url_service_for_control";
        LeanCloudConfigLoader.findInBackground(queryUrl, instance -> {
//        new LCQuery<>("Configuration")
//                .whereEqualTo("name", queryUrl)
//                .limit(1)
//                .findInBackground().subscribe(new Observer<List<LCObject>>() {
//                    @Override
//                    public void onSubscribe(Disposable d) {
//
//                    }
//
//                    @Override
//                    public void onNext(List<LCObject> avObjects) {
            if (/*avObjects != null && !avObjects.isEmpty() && avObjects.get(0).getString("value") != null*/instance != null && StringUtil.isNotEmpty(instance.value)) {
//                            ((App) Utils.getApp()).servicePageUrl = /*avObjects.get(0).getString("value")*/instance.value;
                ServicePageUrl.url = instance.value;
                mAgentWeb.getUrlLoader().loadUrl(ServicePageUrl.url);
            }
//                    }
//
//                    @Override
//                    public void onError(Throwable e) {
//
//                    }
//
//                    @Override
//                    public void onComplete() {
//
//                    }
        });
    }

    @Override
    public void onResume() {
        super.onResume();
//        Activity activity = getActivity();
//        if (activity instanceof MainActivity) {
//            ((MainActivity) activity).setCurrentTab(2);
//        }
    }
}