package com.bingce.controlnetwork.fragment.base;

import android.view.View;

import androidx.annotation.IdRes;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.Lifecycle;

import com.bingce.controlapphelper.util.IUIRunner;

public class BaseFragment extends Fragment implements IUIRunner {
    public void runOnUI(Runnable runnable) {
        if (getActivity() == null) {
            return;
        }
        getActivity().runOnUiThread(runnable);
    }

    final protected <T extends View> T findViewById(@IdRes int id) {
        if (getActivity() == null) {
            return null;
        }
        return getActivity().findViewById(id);
    }

    final protected void setCreatedData(Runnable runnable) {
        if (getLifecycle().getCurrentState().isAtLeast(Lifecycle.State.CREATED)) {
            runnable.run();
        }
    }

}
