package com.bingce.controlnetwork.fragment.bottompage

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.bingce.controlapphelper.util.FastClickUtil
import com.bingce.controlnetwork.adapter.BaseAdapter
import com.bingce.controlnetwork.databinding.ListItemIndexTextSelectableLayoutBinding

class BottomPageAdapter(val context: Context, private val dataList: List<BottomBean>, callBack: CallBack) :
    BaseAdapter<BottomBean, ViewHolder>(dataList) {

    private val callBack: CallBack

    init {
        this.callBack = callBack
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val bean = dataList[position]
        holder.mBinding.index.text = (position + 1).toString()
        holder.mBinding.text.text = bean.name
        holder.mBinding.status.visibility = if (bean.isSelect) View.VISIBLE else View.GONE

        holder.mBinding.root.setOnClickListener {
            FastClickUtil.click {
                callBack.back(bean)
            }
        }
    }

    override fun createVH(parent: ViewGroup, viewType: Int): ViewHolder {
        val binding = ListItemIndexTextSelectableLayoutBinding.inflate(LayoutInflater.from(context), parent, false)
        return ViewHolder(binding)
    }

    interface CallBack {
        fun back(bottomBean: BottomBean)
    }

}