package com.bingce.controlnetwork.fragment.projectdetail

import android.os.Bundle
import android.view.View
import androidx.fragment.app.Fragment
import androidx.fragment.app.viewModels
import com.bingce.controlapphelper.datasource.database.SurveyorDataBase
import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory
import com.bingce.controlapphelper.datasource.database.config.ConfigConstants
import com.bingce.controlapphelper.util.Tools
import com.bingce.controlnetwork.R
import com.bingce.controlnetwork.fragment.heighttraverse.viewmodel.HeightCreateOrEditVm
import com.bingce.controlnetwork.fragment.projectdetail.content.RouteFragment

class ProjectDetailHeightTraverseFragment : ProjectDetailFragment() {

    private lateinit var routeFragment: RouteFragment

    private val heightCreateOrEditVm: HeightCreateOrEditVm by viewModels()

    companion object {
        @JvmField
        val TAG = ProjectDetailHeightTraverseFragment::class.simpleName

        @JvmStatic
        fun newInstance(bundle: Bundle): ProjectDetailHeightTraverseFragment {
            val fragment = ProjectDetailHeightTraverseFragment()
            fragment.arguments = bundle
            return fragment
        }
    }

    override fun getContentFragment(): Fragment {
        routeFragment = RouteFragment.newInstance(projectId)
        return routeFragment
    }

    override fun saveDefaultProjectAndSoOn(): String? {
        val routeId =
            routeFragment.getSurveyorRouteId() ?: return Tools.getString(R.string.no_route_yet)
        SurveyorDataBase.getInstance().runInTransaction {
            SurveyorDatabaseFactory.instance.configDataSource.setSync(
                ConfigConstants.KEY_DEFAULT_PROJECT_ID,
                projectId
            )

            SurveyorDatabaseFactory.instance.configDataSource.setSync(
                ConfigConstants.KEY_DEFAULT_ROUTE_ID,
                routeId
            )
        }
        return null
    }

    override fun clickCreateStation() {
        heightCreateOrEditVm.showCreateOrEditDialog(
            projectId,
            routeId = null,
            childFragmentManager,
            viewLifecycleOwner
        )
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        mBinding.tvCycleTitle.text = getString(R.string.route)
        mBinding.ilBtn.btnOne.text = getString(R.string.create_new_route)
        mBinding.ivCycleArrow.visibility = View.GONE
    }

}