package com.bingce.controlnetwork.fragment.projectedit

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory
import com.bingce.controlapphelper.datasource.database.config.IConfigDataSource
import com.bingce.controlnetwork.databinding.FragmentProjectEditTriangleBinding

/**
 * 三角测量和联系测量共用
 */
class ProjectEditTriangleFragment : AbstractProjectEditFragment() {

    init {
        initSelectToleranceLauncher(this)
    }

    private var _binding: FragmentProjectEditTriangleBinding? = null

    private val mBinding get() = _binding!!


    val configDataSource: IConfigDataSource = SurveyorDatabaseFactory.instance.configDataSource

    override fun createContentView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        _binding = FragmentProjectEditTriangleBinding.inflate(inflater, container, false)
        return mBinding.root
    }

    override fun quitWhenTouchBg(): Boolean {
        return true
    }

    override fun onDestroyView() {
        super.onDestroyView()
        _binding = null
    }

    override fun getCurrentProjectName(): String {
        return mBinding.il.editor.text.toString().trim()
    }

    override fun setToleranceName(name: String) {
        mBinding.il.selectTolerance.text = name
    }

    override fun setProjectName(name: String) {
        mBinding.il.editor.setText(name)
    }

    override fun setShowSlopSwitch(isChecked: Boolean) {
        mBinding.il.showSlopSwitch.isChecked = isChecked
    }

    override fun getToleranceBtn(): View {
        return mBinding.il.selectTolerance
    }

    override suspend fun saveOtherRecord(projectId: String) {
        //暂无使用
    }

    override fun getShowSlopSwitch(): Boolean {
        return mBinding.il.showSlopSwitch.isChecked
    }


}