package com.bingce.controlnetwork.fragment.stationsetting

import android.os.Bundle
import android.view.Menu
import android.view.MenuInflater
import android.view.MenuItem
import com.bingce.controlnetwork.fragment.base.BaseFragment
import com.bingce.controlnetwork.R

abstract class BaseStationSettingFragment : BaseFragment() {

    companion object {
        const val DEFAULT_TEMPERATURE = "12"
        const val DEFAULT_HUMIDITY = "60"
        const val DEFAULT_AIR_PRESSURE = "1013.3"
        const val DEFAULT_CONSTANT = "0"
        const val DEFAULT_INSTRUMEN_HEIGHT = "0"

        const val KEY_SURVEYOR_STATION_ID = "___surveyor_station_id___"

    }

    protected abstract fun clickConfirm()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setHasOptionsMenu(true)
    }

    override fun onCreateOptionsMenu(menu: Menu, inflater: MenuInflater) {
        inflater.inflate(R.menu.menu_confirm, menu)
        super.onCreateOptionsMenu(menu, inflater)
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        if (R.id.menu_confirm === item.itemId) {
            clickConfirm()
        }
        return super.onOptionsItemSelected(item)
    }

    /**
     * 返回非空测站id
     */
    fun stationId(): String {
        return requireArguments().getString(KEY_SURVEYOR_STATION_ID)!!
    }

}