package com.bingce.controlnetwork.func.level.adapter;


import android.content.Context;
import android.view.ViewGroup;

import androidx.annotation.NonNull;

import com.bingce.controlapphelper.datasource.database.leveling.route.LevelRouteRecord;
import com.bingce.controlapphelper.model.LevelingMeasureOrderUtil;

import com.bingce.controlnetwork.databinding.ItemLevelRouteListBinding;
import com.bingce.controlnetwork.newui.adapter.BaseAdapterNew;


public class LevelRouteListAdapter extends BaseAdapterNew<LevelRouteListViewHolder, LevelRouteRecord> {

    public LevelRouteListAdapter(Context context) {
        super(context);
    }

    @NonNull
    @Override
    public LevelRouteListViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new LevelRouteListViewHolder(ItemLevelRouteListBinding.inflate(getInflater(), parent, false));
    }

    @Override
    protected void onBindViewHolderDo(LevelRouteListViewHolder holder, int position) {
        LevelRouteRecord bean = mDataList.get(position);
        holder.mBinding.tvIndex.setText(String.valueOf(position + 1));
        holder.mBinding.tvRouteName.setText(bean.getRouteName());
        holder.mBinding.tvOrderType.setText(LevelingMeasureOrderUtil.INSTANCE.getTextByLevelingMeasureOrder(bean.getLevelingMeasureOrder()));
        holder.mBinding.tvWay.setText(bean.getObservationDirection());
    }


}
