package com.bingce.controlnetwork.func.level.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.fragment.AbstractFullScreenDialogFragment;

/**
 * 新建编辑i角检测
 */
public class LevelIDetectionCreateFragment extends AbstractFullScreenDialogFragment {
    @Override
    protected View createContentView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_level_i_detection_create_edit, container, false);
        EditText editText = view.findViewById(R.id.editor);
        if (editText != null && getArguments() != null) {
            editText.setText(getArguments().getString(KEY_DEFAULT_STRING));
        }
        return view;
    }

    @Override
    protected void onConfirm() {
        Bundle args = new Bundle();
        if (getView() != null) {
            EditText editText = getView().findViewById(R.id.editor);
            if (editText.getText() != null) {
                String string = editText.getText().toString();
                if (string.isEmpty()) {
                    Toast.makeText(getContext(),
                            R.string.string_no_empty,
                            Toast.LENGTH_SHORT).show();
                    return;
                }
                args.putString(KEY_STRING_RESULT, string);
            }
        }
        getParentFragmentManager()
                .setFragmentResult(KEY_REQUEST_INPUT, args);
        super.onConfirm();
    }

    private static final String TAG = LevelIDetectionCreateFragment.class.getName();
    private static final String KEY_REQUEST_INPUT = LevelIDetectionCreateFragment.class.getName() + "_REQUEST";
    private static final String KEY_STRING_RESULT = LevelIDetectionCreateFragment.class.getName() + "_result";
    private static final String KEY_DEFAULT_STRING = LevelIDetectionCreateFragment.class.getName() + "__DEFAULT_STRING";


    public static void input(FragmentManager fragmentManager,
                             String title,
                             String defaultString,
                             LifecycleOwner lifecycleOwner,
                             IInputCallback callback) {
        Bundle args = new Bundle();
        LevelIDetectionCreateFragment fragment = new LevelIDetectionCreateFragment();
        fragment.setArguments(args);
        if (defaultString != null) {
            args.putString(KEY_DEFAULT_STRING, defaultString);
        }
        AbstractFullScreenDialogFragment.setArgs(args, title, null);
        fragmentManager
                .setFragmentResultListener(
                        KEY_REQUEST_INPUT,
                        lifecycleOwner,
                        (requestKey, result) -> {
                            if (KEY_REQUEST_INPUT.equals(requestKey)) {
                                callback.onGetInput(result.getString(KEY_STRING_RESULT));
                            }
                        });
        fragment.show(fragmentManager, TAG);
    }

    public interface IInputCallback {
        void onGetInput(String string);
    }
}
