package com.bingce.controlnetwork.func.level.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatDialogFragment;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.newui.widget.switchtext.SwitchWithText;


public class LevelInputAllowFragment extends AppCompatDialogFragment {

    public static String KEY_AUTO = "KEY_AUTO";
    public static String KEY_REQUEST = "KEY_REQUEST";

    public static void show(FragmentManager fragmentManager, LifecycleOwner lifecycleOwner,
                            boolean auto, IConfirmCallback callback) {
        Bundle args = new Bundle();
        LevelInputAllowFragment fragment = new LevelInputAllowFragment();
        fragment.setArguments(args);
        args.putBoolean(KEY_AUTO, auto);

        fragmentManager
                .setFragmentResultListener(
                        KEY_REQUEST,
                        lifecycleOwner,
                        (requestKey, result) -> {
                            if (KEY_REQUEST.equals(requestKey)) {
                                if (callback != null) {
                                    callback.onConfirm(result.getBoolean(KEY_AUTO));
                                }
                            }
                        });

        fragment.show(fragmentManager, null);

    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View contentView = inflater.inflate(R.layout.fragment_level_input_allow, container, false);
        SwitchWithText receiveDataType = contentView.findViewById(R.id.receiveDataType);

        receiveDataType.setChecked(getAuto());

        contentView.findViewById(R.id.btnConfirm).setOnClickListener(v -> {
            Bundle bundle = new Bundle();
            bundle.putBoolean(KEY_AUTO, receiveDataType.isChecked());
            getParentFragmentManager()
                    .setFragmentResult(KEY_REQUEST, bundle);
            dismissAllowingStateLoss();
        });

        return contentView;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if (getDialog() == null) {
            return;
        }
        getDialog().getWindow().setLayout(
                WindowManager.LayoutParams.MATCH_PARENT,
                WindowManager.LayoutParams.WRAP_CONTENT);
    }

    public interface IConfirmCallback {
        void onConfirm(Boolean auto);
    }

    /**
     * 仪器获取
     */
    private boolean getAuto() {
        if (getArguments() != null) {
            return getArguments().getBoolean(KEY_AUTO);
        }
        return true;
    }

}
