package com.bingce.controlnetwork.func.level.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.bingce.controlnetwork.fragment.SelectProjectAndSurveyorCycleFragment;
import com.google.android.material.bottomsheet.BottomSheetDialogFragment;

import com.bingce.controlnetwork.R;

/**
 * 水准选择下一站观测方式
 */
public class SelectLevelNextStationTypeFragment extends BottomSheetDialogFragment {
    public static final String TAG = SelectProjectAndSurveyorCycleFragment.class.getName();
    private static final String KEY_REQUEST_SELECT = "__SELECT__";
    private static final String KEY_TYPE = "__SELECT_TYPE__";
    public static final String TYPE_CONTINUE_OBSERVE = "TYPE_CONTINUE_OBSERVE";
    public static final String TYPE_INTERMITTENT = "TYPE_INTERMITTENT";
    public static final String TYPE_END_STATION = "TYPE_END_STATION";

    private SelectLevelNextStationTypeFragment() {
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(
                R.layout.fragment_select_level_next_station_type,
                container,
                false);
        initClickListener(view);
        return view;
    }

    private void initClickListener(View view) {
        setOnClickListener(view, R.id.continueObserve, v -> backData(TYPE_CONTINUE_OBSERVE));
        setOnClickListener(view, R.id.intermittent, v -> backData(TYPE_INTERMITTENT));
        setOnClickListener(view, R.id.endStation, v -> backData(TYPE_END_STATION));
        setOnClickListener(view, R.id.cancel, v -> dismiss());
    }

    private void backData(String type) {
        Bundle args = new Bundle();
        args.putString(KEY_TYPE, type);
        getParentFragmentManager().setFragmentResult(KEY_REQUEST_SELECT, args);
        dismissAllowingStateLoss();
    }

    private static void setOnClickListener(View root, int id, View.OnClickListener onClickListener) {
        View view = root.findViewById(id);
        if (view != null) {
            view.setOnClickListener(onClickListener);
        }
    }

    public static void select(FragmentManager fragmentManager,
                              @NonNull LifecycleOwner lifecycleOwner,
                              IOnSelectCallback callback) {
        SelectLevelNextStationTypeFragment fragment = new SelectLevelNextStationTypeFragment();
        fragmentManager
                .setFragmentResultListener(
                        KEY_REQUEST_SELECT,
                        lifecycleOwner,
                        (requestKey, result) -> {
                            if (KEY_REQUEST_SELECT.equals(requestKey)) {
                                callback.onSurveyorCycleSelected(result.getString(KEY_TYPE));
                            }
                        });
        fragment.show(fragmentManager, TAG);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if (getDialog() == null) {
            return;
        }
        getDialog().getWindow().setLayout(
                WindowManager.LayoutParams.MATCH_PARENT,
                WindowManager.LayoutParams.WRAP_CONTENT);
    }

    public interface IOnSelectCallback {
        void onSurveyorCycleSelected(String type);
    }
}