package com.bingce.controlnetwork.func.level.idetection.util

import com.bingce.controlnetwork.func.level.idetection.LevelIDetectionSurveyorData
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.MEASURE_TIME_0
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.MEASURE_TIME_1
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.MEASURE_TIME_2
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.MEASURE_TIME_3
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.MEASURE_TIME_4
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.RULER_TYPE_0
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.RULER_TYPE_1
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.STATION_TYPE_0
import com.bingce.controlapphelper.datasource.database.leveling.idetection.constants.LevelIDetectionConstant.STATION_TYPE_1
import com.bingce.controlapphelper.datasource.database.leveling.idetection.record.LevelIDetectionRecord

/**
 * 查找工具
 */
class LevelIDetectionFindUtil {

    fun getFindMeasureList(iDetectionId: String): List<LevelIDetectionRecord> {
        val station1 = STATION_TYPE_0
        val station2 = STATION_TYPE_1
        val ruler1 = RULER_TYPE_0
        val ruler2 = RULER_TYPE_1
        val measureTime1 = MEASURE_TIME_0
        val measureTime2 = MEASURE_TIME_1
        val measureTime3 = MEASURE_TIME_2
        val measureTime4 = MEASURE_TIME_3
        val measureTime5 = MEASURE_TIME_4

        return listOf(
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler1,
                measureTime1
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler1,
                measureTime2
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler1,
                measureTime3
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler1,
                measureTime4
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler1,
                measureTime5
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler2,
                measureTime1
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler2,
                measureTime2
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler2,
                measureTime3
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler2,
                measureTime4
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station1,
                ruler2,
                measureTime5
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler1,
                measureTime1
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler1,
                measureTime2
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler1,
                measureTime3
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler1,
                measureTime4
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler1,
                measureTime5
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler2,
                measureTime1
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler2,
                measureTime2
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler2,
                measureTime3
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler2,
                measureTime4
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                station2,
                ruler2,
                measureTime5
            )
        )
    }

    fun getFindMeasureList(
        iDetectionId: String,
        stationType: Int
    ): List<LevelIDetectionRecord> {
        val ruler1 = RULER_TYPE_0
        val ruler2 = RULER_TYPE_1
        val measureTime1 = MEASURE_TIME_0
        val measureTime2 = MEASURE_TIME_1
        val measureTime3 = MEASURE_TIME_2
        val measureTime4 = MEASURE_TIME_3
        val measureTime5 = MEASURE_TIME_4

        return listOf(
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler1,
                measureTime1
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler1,
                measureTime2
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler1,
                measureTime3
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler1,
                measureTime4
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler1,
                measureTime5
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler2,
                measureTime1
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler2,
                measureTime2
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler2,
                measureTime3
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler2,
                measureTime4
            ),
            LevelIDetectionRecord.create(
                iDetectionId,
                stationType,
                ruler2,
                measureTime5
            )
        )
    }

    fun find(
        recordList: List<LevelIDetectionRecord>,
        findCase: (LevelIDetectionRecord) -> Boolean
    ): LevelIDetectionSurveyorData? {
        for (record in recordList) {
            if (findCase(record)) {
                val surveyorData = LevelIDetectionSurveyorData("")
                surveyorData.currentStationType = record.stationType
                surveyorData.currentRulerType = record.rulerType
                surveyorData.currentMeasureTime = record.measureTime
                return surveyorData
            }
        }
        return null
    }

}