package com.bingce.controlnetwork.func.level.idetection.viewmodel

import androidx.lifecycle.LiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.bingce.controlapphelper.datasource.database.leveling.LevelingDbFactory
import com.bingce.controlapphelper.datasource.database.leveling.idetection.list.LevelIDetectionList
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.launch

class LevelIDetectionListVm : ViewModel() {

    fun getListLiveData(projectId: String): LiveData<List<LevelIDetectionList>> {
        return LevelingDbFactory.instance.iDetectionListDataSource.getListByProjectIdDescLiveData(
            projectId
        )
    }

    /**
     * 创建i角检测
     */
    fun saveNewRecord(projectId: String, name: String) {
        viewModelScope.launch(Dispatchers.IO) {
            val bean = LevelIDetectionList.create(projectId, name)
            LevelingDbFactory.instance.iDetectionListDataSource.save(bean)
        }
    }

    /**
     * 创建i角检测
     */
    fun deleteRecord(bean: LevelIDetectionList) {
        viewModelScope.launch(Dispatchers.IO) {
            LevelingDbFactory.instance.iDetectionListDataSource.delete(bean)
        }
    }


}