package com.bingce.controlnetwork.func.level.util

import androidx.annotation.WorkerThread
import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory
import com.bingce.controlapphelper.datasource.database.leveling.LevelingDbFactory
import com.bingce.controlapphelper.datasource.database.point.PointRecord
import com.bingce.controlapphelper.util.RegExUtil

object LevelPointUtilTj {
    @WorkerThread
    @JvmStatic
    fun createFrontPointByBackPointId(
        routeId: String,
        backPointId: String,
        firstStaion: Boolean = false,
        endStattion: Boolean = false,
    ): PointRecord {
        val frontPoint = if (endStattion) {
            val route = LevelingDbFactory.instance.levelDataSource.getByIdSync(routeId)
            SurveyorDatabaseFactory.instance.pointDataSource.findByIdSync(route?.endPointId)
        } else if (firstStaion) {
            createHidePoint("1")
        } else {
            val backPoint = SurveyorDatabaseFactory.instance.pointDataSource.findByIdSync(backPointId)
            val frontPointName = RegExUtil.getPointNameIncrease(backPoint.getName())
            createHidePoint(frontPointName)
        }
        return frontPoint
    }

    private fun createHidePoint(pointName: String): PointRecord {
        val point = PointRecord.createHidePoint(pointName)
        //存点
        SurveyorDatabaseFactory.instance.pointDataSource.saveSync(point)
        return point
    }

}