package com.bingce.controlnetwork.func.level.util

import androidx.annotation.WorkerThread
import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory

/**
 * 水准测站设置上次值
 */
object LevelStationSettingLastData {

    private const val KEY_WATCHER = "LEVEL_STATION_SETTING_LAST_DATA_WATCHER"
    private const val KEY_RECORDER = "LEVEL_STATION_SETTING_LAST_DATA_RECORDER"
    private const val KEY_EXAMINER = "LEVEL_STATION_SETTING_LAST_DATA_EXAMINER"
    private const val KEY_FRONT_FOOT_NUMBER = "LEVEL_STATION_SETTING_LAST_DATA_FRONT_FOOT_NUMBER"
    private const val KEY_BACK_FOOT_NUMBER = "LEVEL_STATION_SETTING_LAST_DATA_BACK_FOOT_NUMBER"
    private const val KEY_FRONT_FOOT_NUMBER_2 =
        "LEVEL_STATION_SETTING_LAST_DATA_FRONT_FOOT_NUMBER_2"
    private const val KEY_BACK_FOOT_NUMBER_2 = "LEVEL_STATION_SETTING_LAST_DATA_BACK_FOOT_NUMBER_2"
    private const val KEY_INSTRUMENT_MODEL = "LEVEL_STATION_SETTING_LAST_DATA_INSTRUMENT_MODEL"
    private const val KEY_DEVICE_NUMBER = "LEVEL_STATION_SETTING_LAST_DATA_DEVICE_NUMBER"
    private const val KEY_STEEL_RULE_PARAM = "LEVEL_STATION_SETTING_LAST_DATA_STEEL_RULE_PARAM"
    private const val KEY_RULER_LENGTH_PROVING_TEMPERATURE =
        "LEVEL_STATION_SETTING_LAST_DATA_RULER_LENGTH_PROVING_TEMPERATURE"
    private const val KEY_TEMPERATURE = "LEVEL_STATION_SETTING_LAST_DATA_TEMPERATURE"
    private const val KEY_WEATHER = "LEVEL_STATION_SETTING_LAST_DATA_WEATHER"
    private const val KEY_IMAGING = "LEVEL_STATION_SETTING_LAST_DATA_IMAGING"
    private const val KEY_SUN_DIRECTION = "LEVEL_STATION_SETTING_LAST_DATA_SUN_DIRECTION"
    private const val KEY_WIND_DIRECTION = "LEVEL_STATION_SETTING_LAST_DATA_WIND_DIRECTION"
    private const val KEY_WIND_SPEED = "LEVEL_STATION_SETTING_LAST_DATA_WIND_SPEED"
    private const val KEY_ROADS = "LEVEL_STATION_SETTING_LAST_DATA_ROADS"
    private const val KEY_SOIL = "LEVEL_STATION_SETTING_LAST_DATA_SOIL"
    private const val KEY_RULER_TYPE = "LEVEL_STATION_SETTING_LAST_DATA_RULER_TYPE"
    private const val KEY_RULER_RECEPT_TYPE = "LEVEL_STATION_SETTING_LAST_DATA_RULER_RECEPT_TYPE"
    private const val KEY_RULER_CORRECTION_FACTOR =
        "LEVEL_STATION_SETTING_LAST_DATA_RULER_CORRECTION_FACTOR"

    @WorkerThread
    fun getExaminer(): String? {
        return get(KEY_EXAMINER)
    }

    @WorkerThread
    fun setExaminer(examiner: String?) {
        save(KEY_EXAMINER, examiner)
    }

    @WorkerThread
    fun getRecorder(): String? {
        return get(KEY_RECORDER)
    }

    @WorkerThread
    fun setRecorder(recorder: String?) {
        save(KEY_RECORDER, recorder)
    }

    @WorkerThread
    fun getWatcher(): String? {
        return get(KEY_WATCHER)
    }

    @WorkerThread
    fun setWatcher(watcher: String?) {
        save(KEY_WATCHER, watcher)
    }

    @WorkerThread
    fun getFrontFootNumber(): String? {
        return get(KEY_FRONT_FOOT_NUMBER)
    }

    @WorkerThread
    fun setFrontFootNumber(watcher: String?) {
        save(KEY_FRONT_FOOT_NUMBER, watcher)
    }

    @WorkerThread
    fun getFrontFootNumber2(): String? {
        return get(KEY_FRONT_FOOT_NUMBER_2)
    }

    @WorkerThread
    fun setFrontFootNumber2(watcher: String?) {
        save(KEY_FRONT_FOOT_NUMBER_2, watcher)
    }

    @WorkerThread
    fun getBackFootNumber(): String? {
        return get(KEY_BACK_FOOT_NUMBER)
    }

    @WorkerThread
    fun setBackFootNumber(watcher: String?) {
        save(KEY_BACK_FOOT_NUMBER, watcher)
    }

    @WorkerThread
    fun getBackFootNumber2(): String? {
        return get(KEY_BACK_FOOT_NUMBER_2)
    }

    @WorkerThread
    fun setBackFootNumber2(watcher: String?) {
        save(KEY_BACK_FOOT_NUMBER_2, watcher)
    }

    @WorkerThread
    fun getInstrumentModel(): String? {
        return get(KEY_INSTRUMENT_MODEL)
    }

    @WorkerThread
    fun setInstrumentModel(watcher: String?) {
        save(KEY_INSTRUMENT_MODEL, watcher)
    }

    @WorkerThread
    fun getDeviceNumber(): String? {
        return get(KEY_DEVICE_NUMBER)
    }

    @WorkerThread
    fun setDeviceNumber(watcher: String?) {
        save(KEY_DEVICE_NUMBER, watcher)
    }

    @WorkerThread
    fun getSteelRuleParam(): String? {
        return get(KEY_STEEL_RULE_PARAM)
    }

    @WorkerThread
    fun setTemperature(watcher: String?) {
        save(KEY_TEMPERATURE, watcher)
    }

    @WorkerThread
    fun getTemperature(): String? {
        return get(KEY_TEMPERATURE)
    }

    @WorkerThread
    fun setWeather(watcher: String?) {
        save(KEY_WEATHER, watcher)
    }

    @WorkerThread
    fun getWeather(): String? {
        return get(KEY_WEATHER)
    }

    @WorkerThread
    fun setImaging(watcher: String?) {
        save(KEY_IMAGING, watcher)
    }

    @WorkerThread
    fun getImaging(): String? {
        return get(KEY_IMAGING)
    }


    /////////////
    @WorkerThread
    fun setSteelRuleParam(watcher: String?) {
        save(KEY_STEEL_RULE_PARAM, watcher)
    }

    @WorkerThread
    fun getRulerLengthProvingTemperature(): String? {
        return get(KEY_RULER_LENGTH_PROVING_TEMPERATURE)
    }

    @WorkerThread
    fun setRulerLengthProvingTemperature(watcher: String?) {
        save(KEY_RULER_LENGTH_PROVING_TEMPERATURE, watcher)
    }

    @WorkerThread
    fun getSunDirection(): String? {
        return get(KEY_SUN_DIRECTION)
    }

    @WorkerThread
    fun setSunDirection(watcher: String?) {
        save(KEY_SUN_DIRECTION, watcher)
    }

    @WorkerThread
    fun getWindDirection(): String? {
        return get(KEY_WIND_DIRECTION)
    }

    @WorkerThread
    fun setWindDirection(watcher: String?) {
        save(KEY_WIND_DIRECTION, watcher)
    }

    @WorkerThread
    fun getWindSpeed(): String? {
        return get(KEY_WIND_SPEED)
    }

    @WorkerThread
    fun setWindSpeed(watcher: String?) {
        save(KEY_WIND_SPEED, watcher)
    }

    @WorkerThread
    fun getRoads(): String? {
        return get(KEY_ROADS)
    }

    @WorkerThread
    fun setRoads(watcher: String?) {
        save(KEY_ROADS, watcher)
    }

    @WorkerThread
    fun getSoil(): String? {
        return get(KEY_SOIL)
    }

    @WorkerThread
    fun setSoil(watcher: String?) {
        save(KEY_SOIL, watcher)
    }

    @WorkerThread
    fun getRulerType(): String? {
        return get(KEY_RULER_TYPE)
    }

    @WorkerThread
    fun setRulerType(watcher: String?) {
        save(KEY_RULER_TYPE, watcher)
    }

    @WorkerThread
    fun getRulerReceptType(): String? {
        return get(KEY_RULER_RECEPT_TYPE)
    }

    @WorkerThread
    fun setRulerReceptType(watcher: String?) {
        save(KEY_RULER_RECEPT_TYPE, watcher)
    }

    @WorkerThread
    fun getRulerCorrectionFactor(): String? {
        return get(KEY_RULER_CORRECTION_FACTOR)
    }

    @WorkerThread
    fun setRulerCorrectionFactor(watcher: String?) {
        save(KEY_RULER_CORRECTION_FACTOR, watcher)
    }


    private fun save(key: String, value: String?) {
        SurveyorDatabaseFactory.instance.getConfigDataSource().setSync(key, value)
    }

    private fun get(key: String): String? {
        val measureUnitRecord =
            SurveyorDatabaseFactory.instance.getConfigDataSource()
                .getByKeySync(key)
        return measureUnitRecord?.getConfigValue()
    }

}