package com.bingce.controlnetwork.guide;

import android.app.Activity;
import android.app.Dialog;
import android.view.View;

import androidx.appcompat.widget.Toolbar;

import com.getkeepsafe.taptargetview.TapTarget;
import com.getkeepsafe.taptargetview.TapTargetView;

public class GuideSequence implements ITapTargetProvider {
    private int currentIndex = 0;
    private final int targetCount;
    private final IDelegate delegate;
    private final TapTargetView.Listener listener = new TapTargetView.Listener() {
//        @Override
//        public void onTargetClick(TapTargetView view) {
//            super.onTargetClick(view);
//        }

        @Override
        public void onTargetDismissed(TapTargetView view, boolean userInitiated) {
            super.onTargetDismissed(view, userInitiated);
            //下一个
            delegate.dismiss(currentIndex);
            currentIndex++;
            if (currentIndex >= targetCount) {
                return;
            }
            delegate.show(currentIndex, GuideSequence.this);
        }

//        @Override
//        public void onTargetCancel(TapTargetView view) {
//            super.onTargetCancel(view);
//        }
//
//        @Override
//        public void onTargetLongClick(TapTargetView view) {
//            super.onTargetLongClick(view);
//        }

//        @Override
//        public void onOuterCircleClick(TapTargetView view) {
//            super.onOuterCircleClick(view);
//        }
    };

    public GuideSequence(int targetCount, final IDelegate delegate) {
        this.targetCount = targetCount;
        this.delegate = delegate;
    }

    public void start(int index) {
        if (index < 0) {
            return;
        }
        currentIndex = index;
        delegate.show(currentIndex, this);
    }

    @Override
    public void show4View(Activity activity, View target, String msg, String describe) {
        if (activity.isFinishing()) {
            return;
        }
        if (activity.isDestroyed()) {
            return;
        }
        TapTargetView.showFor(
                activity,
                TapTarget.forView(target, msg, describe).transparentTarget(true),
                listener
        );
    }

    @Override
    public void show4View(Dialog dialog, View target, String msg, String describe) {
        if (!dialog.isShowing()) {
            return;
        }
        TapTargetView.showFor(
                dialog,
                TapTarget.forView(target, msg, describe).transparentTarget(true),
                listener
        );
    }

    @Override
    public void show4ToolbarMenu(Activity activity, Toolbar toolbar, int menuItem, String msg, String describe) {
        if (activity.isFinishing()) {
            return;
        }
        if (activity.isDestroyed()) {
            return;
        }
        TapTargetView.showFor(
                activity,
                TapTarget.forToolbarMenuItem(toolbar, menuItem, msg, describe).transparentTarget(true),
                listener
        );
    }

    public interface IDelegate {
        void show(int index, ITapTargetProvider provider);

        void dismiss(int index);
    }
}
