package com.bingce.controlnetwork.newui.adapter;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;

import com.bingce.controlapphelper.datasource.database.ProjectType;
import com.bingce.controlapphelper.datasource.database.point.PointRecord;
import com.bingce.controlnetwork.databinding.NewItemPointListBinding;
import com.bingce.controlnetwork.newui.viewholder.PointListViewHolder;


public class PointListAdapter extends BaseAdapterNew<PointListViewHolder, PointRecord> {

    private boolean isPlatCoordinate;
    private String projectType;

    public PointListAdapter(Context context) {
        super(context);
    }

    @NonNull
    @Override
    public PointListViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new PointListViewHolder(NewItemPointListBinding.inflate(getInflater(), parent, false));
    }

    @Override
    protected void onBindViewHolderDo(PointListViewHolder holder, int position) {
        PointRecord pointRecordTj = mDataList.get(position);
        //num就是name 因为从天津拷贝过来的
        holder.mBinding.tvPointNum.setText(pointRecordTj.getName());
//        holder.mBinding.tvPointName.setText("");

        holder.mBinding.tvX.setVisibility(View.VISIBLE);
        holder.mBinding.tvY.setVisibility(View.VISIBLE);
        if (ProjectType.isLevel(projectType)) {
            holder.mBinding.tvX.setVisibility(View.GONE);
            holder.mBinding.tvY.setVisibility(View.GONE);
            holder.mBinding.tvZ.setText("高程：" + pointRecordTj.getZ());
        } else {
            holder.mBinding.tvX.setText("X:" + pointRecordTj.getX());
            holder.mBinding.tvY.setText("Y:" + pointRecordTj.getY());
            holder.mBinding.tvZ.setText("Z:" + pointRecordTj.getZ());
        }
    }

    public void setIsPlatCoordinate(boolean isPlatCoordinate) {
        this.isPlatCoordinate = isPlatCoordinate;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }
}
