package com.bingce.controlnetwork.newui.adapter;

import android.content.Context;
import android.view.ViewGroup;

import androidx.annotation.NonNull;

import com.bingce.controlnetwork.databinding.NewItemStationListBinding;
import com.bingce.controlnetwork.newui.model.StationListBean;
import com.bingce.controlnetwork.newui.viewholder.StationListViewHolder;


/**
 * 测站列表adapter
 */
public class StationListAdapter extends BaseAdapterNew<StationListViewHolder, StationListBean> {

    public StationListAdapter(Context context) {
        super(context);
    }

    @NonNull
    @Override
    public StationListViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new StationListViewHolder(NewItemStationListBinding.inflate(getInflater(), parent, false));
    }

    @Override
    protected void onBindViewHolderDo(StationListViewHolder holder, int position) {
        StationListBean bean = mDataList.get(position);
        holder.mBinding.tvIndex.setText(String.valueOf(position + 1));
        holder.mBinding.tvStationName.setText(bean.getStationName());
        holder.mBinding.tvStationType.setText(bean.getStationType());
        holder.mBinding.tvPointOrder.setText(bean.getStationPiontOrder());
    }

}
