package com.bingce.controlnetwork.newui.base;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.viewbinding.ViewBinding;

import com.bingce.controlnetwork.fragment.base.BaseFragment;

public abstract class BaseFragmentBinding<VB extends ViewBinding> extends BaseFragment {
    protected VB mBinding;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        mBinding = getViewBinding(inflater, container);
        return mBinding.getRoot();
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initView();
        initData();
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        mBinding = null;
    }

    protected abstract VB getViewBinding(@NonNull LayoutInflater inflater, @Nullable ViewGroup container);

    protected abstract void initView();

    protected abstract void initData();

    protected String getArgumentString(String key) {
        Bundle bundle = getArguments();
        if (bundle != null) {
            return bundle.getString(key);
        }
        return null;
    }

    protected int getArgumentInt(String key) {
        Bundle bundle = getArguments();
        if (bundle != null) {
            return bundle.getInt(key);
        }
        return -1;
    }

}
