package com.bingce.controlnetwork.newui.configfragment;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.annotation.Keep;

@Keep
public class SelectExportType implements Parcelable {
    public static final String TYPE_CONTROL = "TYPE_CONTROL";
    public static final String TYPE_KE_SHA = "TYPE_KE_SHA";
    public static final String TYPE_NAN_FANG = "TYPE_NAN_FANG";
    public static final String TYPE_QI_FEI = "TYPE_QI_FEI";
    public static final String TYPE_PING_CHA_ZHI_XING = "TYPE_PING_CHA_ZHI_XING";

    private final String name;
    private final String type;
    private boolean isSelect;

    public SelectExportType(String name, String type) {
        this.name = name;
        this.type = type;
    }

    protected SelectExportType(Parcel in) {
        name = in.readString();
        type = in.readString();
        isSelect = in.readByte() != 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(name);
        dest.writeString(type);
        dest.writeByte((byte) (isSelect ? 1 : 0));
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<SelectExportType> CREATOR = new Creator<SelectExportType>() {
        @Override
        public SelectExportType createFromParcel(Parcel in) {
            return new SelectExportType(in);
        }

        @Override
        public SelectExportType[] newArray(int size) {
            return new SelectExportType[size];
        }
    };

    public String getName() {
        return name;
    }

    public String getType() {
        return type;
    }

    public boolean isSelect() {
        return isSelect;
    }

    public void setSelect(boolean select) {
        isSelect = select;
    }
}
