package com.bingce.controlnetwork.newui.projectedit

import androidx.annotation.WorkerThread
import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory
import com.bingce.controlapphelper.datasource.database.config.ConfigConstants


/**
 * 创建项目的保存的上次值
 */
object ProjectLastData {

    /**
     * 测量单位
     */
    @WorkerThread
    fun getMeasureUnit(): String? {
        val measureUnitRecord =
            SurveyorDatabaseFactory.instance.getConfigDataSource()
                .getByKeySync(ConfigConstants.KEY_LAST_MEASURE_UNIT)
        return measureUnitRecord?.getConfigValue()
    }

    @WorkerThread
    fun setMeasureUnit(measureUnit: String?) {
        SurveyorDatabaseFactory.instance.getConfigDataSource()
            .setSync(ConfigConstants.KEY_LAST_MEASURE_UNIT, measureUnit)
    }

    /**
     * 经度
     */
    @WorkerThread
    fun getLongitude(): String? {
        val measureUnitRecord =
            SurveyorDatabaseFactory.instance.getConfigDataSource()
                .getByKeySync(ConfigConstants.KEY_LAST_LONGITUDE)
        return measureUnitRecord?.getConfigValue()
    }

    @WorkerThread
    fun setLongitude(longitude: String?) {
        SurveyorDatabaseFactory.instance.getConfigDataSource()
            .setSync(ConfigConstants.KEY_LAST_LONGITUDE, longitude)
    }

    /**
     * 纬度
     */
    @WorkerThread
    fun getLatitude(): String? {
        val measureUnitRecord =
            SurveyorDatabaseFactory.instance.getConfigDataSource()
                .getByKeySync(ConfigConstants.KEY_LAST_LATITUDE)
        return measureUnitRecord?.getConfigValue()
    }

    @WorkerThread
    fun setLatitude(latitude: String?) {
        SurveyorDatabaseFactory.instance.getConfigDataSource()
            .setSync(ConfigConstants.KEY_LAST_LATITUDE, latitude)
    }


}