package com.bingce.controlnetwork.newui.stationsettingheighttraverse.model

import androidx.annotation.WorkerThread
import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory
import com.bingce.controlapphelper.datasource.database.config.ConfigConstants
import com.bingce.controlapphelper.surveyor.method.model.MeasureConstant

class StationSettingEnvironmentData {
    var temperature: String? = null
    var humidity: String? = null
    var airPress: String? = null


    /**
     * 获取上次数据
     */
    @WorkerThread
    fun getLastData() {
        val configDataSource = SurveyorDatabaseFactory.instance.getConfigDataSource()
        val temperature = configDataSource.getByKeySync(ConfigConstants.KEY_LAST_TEMPERATURE)
        val humidity = configDataSource.getByKeySync(ConfigConstants.KEY_LAST_HUMIDITY)
        val airPress = configDataSource.getByKeySync(ConfigConstants.KEY_LAST_AIR_PRESSURE)

        this.temperature = temperature?.configValue
        this.humidity = humidity?.configValue
        this.airPress = airPress?.configValue
    }

    /**
     * 获取标准气象数据
     */
    fun getStandardData() {
        this.temperature = MeasureConstant.DEFAULT_TEMPERATURE
        this.humidity = MeasureConstant.DEFAULT_HUMIDITY
        this.airPress = MeasureConstant.DEFAULT_AIR_PRESSURE
    }

}