package com.bingce.controlnetwork.newui.widget.swipemenu

import android.content.Context
import android.view.ViewGroup
import com.bingce.controlapphelper.util.Tools

import com.bingce.controlapphelper.widget.swiperecyclerview.SwipeMenu
import com.bingce.controlapphelper.widget.swiperecyclerview.SwipeMenuCreator
import com.bingce.controlapphelper.widget.swiperecyclerview.SwipeMenuItem
import com.bingce.controlnetwork.R
import com.bingce.utils.ScreenUtil

class SwipeMenuDelete(val context: Context) : SwipeMenuCreator {

    companion object {
        @JvmStatic
        fun isDeleteMenu(menuPos: Int) = menuPos == 0
    }

    override fun onCreateMenu(leftMenu: SwipeMenu, rightMenu: SwipeMenu, position: Int) {
        val width = ScreenUtil.dp2px(context, 70f)

        // 1. MATCH_PARENT 自适应高度，保持和Item一样高;
        // 2. 指定具体的高，比如80;
        // 3. WRAP_CONTENT，自身高度，不推荐;
        val height = ViewGroup.LayoutParams.MATCH_PARENT

        // 添加右侧的，如果不添加，则右侧不会出现菜单。
        val deleteItem: SwipeMenuItem =
            SwipeMenuItem(context)
                .setWidth(width)
                .setHeight(height)
                .setBackgroundColor(Tools.getColor(R.color.md_red_400))
                .setText("删除")
                .setTextSize(14)
                .setTextColorResource(R.color.white)
        //添加右侧菜单
        rightMenu.addMenuItem(deleteItem)
    }


}