package com.bingce.controlnetwork.surveyor.state.alonedistance;

import android.os.Bundle;

import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.surveyor.data.ISurveyorData;
import com.bingce.controlapphelper.surveyor.state.StateType;

import net.tatans.tensorflowtts.tts.TtsManager;

import com.bingce.controlnetwork.R;

class _CheckStationSuccessState extends __BaseState {

    public _CheckStationSuccessState(StateManagerAloneDistance stateManager) {
        super(StateType.stationCheckedSuccess, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        ISurveyorData surveyorData = getSurveyorData();
        surveyorData.clearSurveyStateAndPosition();
        //设置测量进度(数据库存储)
        setAllCycleSchedule(SurveyorScheduleConstants.STATUE_VALUE_CHECKED);
        //通知刷新
        tips(getContext().getString(R.string.tips_all_cycle_has_finish_and_checked), null);
        if (isAutoSurveyOpen()) {
            runOnUI(() -> TtsManager.getInstance().speak(getContext().getString(R.string.tips_all_cycle_has_finish_and_checked)));
        }
        //清除测量状态，进入idle，停止自动测量
        enterIdleAndClearSurveyStateAndResetAutoMode(true);
    }
}
