package com.bingce.controlnetwork.surveyor.state.alonedistance;

import android.content.Context;
import android.os.Bundle;

import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.LifecycleOwner;

import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory;
import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleRecord;
import com.bingce.controlapphelper.surveyor.data.CachedDataAloneDistance;
import com.bingce.controlapphelper.surveyor.method.SurveyorAdjustMethod;
import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.controlnetwork.fragment.StationDataAdjustDialogFragment;
import com.bingce.controlnetwork.fragment.TipsFragment;
import com.bingce.utils.ThreadPoolUtil;

import java.util.ArrayList;

/**
 * 平差计算
 */
public class _DoCalAdjustState extends __BaseState {

    public _DoCalAdjustState(StateManagerAloneDistance stateManager) {
        super(StateType.doCalAdjust, stateManager);
    }

    @Override
    public void enter(Bundle args) {

    }

    public static void doCalAdjust(String stationId, CachedDataAloneDistance cachedData, Context context, FragmentManager fragmentManager
            , LifecycleOwner lifecycleOwner) {
        ThreadPoolUtil.execute(() -> {
            SurveyorAdjustMethod.calAloneDistance(
                    stationId, cachedData, new SurveyorAdjustMethod.ICallback() {
                        @Override
                        public void onGet(ArrayList<SurveyorAdjustMethod.Item> finalItemList, Boolean isShowSlopDistance) {
//                            //清除测量状态，进入idle，停止自动测量
//                            enterIdleAndClearSurveyStateAndResetAutoMode(true);
                            //展示结果数据
                            //检测归零值是否为负，如果是需要+2PI
                            for (SurveyorAdjustMethod.Item item : finalItemList) {
                                if (item.getHorAngle() < 0) {
                                    item.setHorAngle(Math.PI * 2 + item.getHorAngle());
                                }
                            }
                            StationDataAdjustDialogFragment.showDialog(StationDataAdjustDialogFragment.TYPE_ALONE_DISTANCE, finalItemList, isShowSlopDistance, fragmentManager);
                        }

                        @Override
                        public void onFailure(String error) {
                            ThreadPoolUtil.executeInMain(() -> {
                                TipsFragment.tipsOnly(fragmentManager, lifecycleOwner, context, error);
                            });
                        }
                    });

            //伴随平差 设置进度为通过检测
            SurveyorDatabaseFactory
                    .instance
                    .getScheduleDataSource()
                    .record(
                            new SurveyorScheduleRecord(
                                    SurveyorScheduleConstants.getAllCycleScheduleKey(stationId, SurveyorScheduleConstants.SCHEDULE_OR_CYCLE_TYPE_ALONE_DISTANCE),
                                    SurveyorScheduleConstants.STATUE_VALUE_CHECKED));

        });

    }
}
