package com.bingce.controlnetwork.surveyor.state.alonedistance;

import android.os.Bundle;

import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory;
import com.bingce.controlapphelper.datasource.database.config.ConfigConstants;
import com.bingce.controlapphelper.datasource.database.config.IConfigDataSource;
import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.utils.ThreadPoolUtil;

import com.bingce.controlnetwork.R;

/**
 * 删除本测站所有测回数据
 * 对于钢丝测距 所有两测回数据都在一个view里显示了，不用切换
 */
class _DoDeleteAllCycleState extends __BaseState {

    private static final String KEY_STATION_ID = "__station_id";

    static Bundle args(String stationId) {
        Bundle args = new Bundle();
        args.putString(KEY_STATION_ID, stationId);
        return args;
    }

    public _DoDeleteAllCycleState(StateManagerAloneDistance stateManager) {
        super(StateType.doDeleteAllCycle, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        String stationId = args.getString(KEY_STATION_ID);

        optionTipsWithStandStill(getContext().getString(R.string.tips_delete_station_all_surveyor_records),
                () -> deleteAllCycleData(stationId));
    }

    private void deleteAllCycleData(String stationId) {
        ThreadPoolUtil.execute(() -> {
            //删除数据
            getCachedData().deleteAloneDistanceRecord(stationId);

            //清除已经提示测站可以检测标识
            IConfigDataSource configDataSource =
                    SurveyorDatabaseFactory.instance.getConfigDataSource();
            String key = ConfigConstants.KEY_CONFIG_STATION_CHECK_REMINDED + stationId;
            configDataSource.setSync(key, ConfigConstants.VALUE_NO);

            //重置所有测回进度
            setAllCycleScheduleSync(SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);
            setSingleCycleScheduleSync(cycleIndexDefault, SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);

            //从第一测回开始
            setCurrentCycle(cycleIndexDefault);
            //重新测量，并刷新
            findTargetFromBeginInCurrentCycle(true);
        });
    }


}
