package com.bingce.controlnetwork.surveyor.state.alonedistance;

import android.os.Bundle;

import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory;
import com.bingce.controlapphelper.datasource.database.config.ConfigConstants;
import com.bingce.controlapphelper.datasource.database.config.IConfigDataSource;
import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.surveyor.state.StateType;

import com.bingce.controlnetwork.R;

class _DoDeleteCurrentCycleState extends __BaseState {
    public _DoDeleteCurrentCycleState(StateManagerAloneDistance stateManager) {
        super(StateType.doDeleteCurrentCycle, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        String stationId = args.getString(KEY_STATION_ID);
        int cycleIndex = args.getInt(KEY_PERIOD_INDEX);

        optionTipsWithStandStill(getContext().getString(R.string.tips_delete_current_cycle_surveyor_record),
                () -> {
                    //删除数据
                    getCachedData().deleteAloneDistanceRecord(stationId, cycleIndex);

                    //清除已经提示测站可以检测标识
                    IConfigDataSource configDataSource =
                            SurveyorDatabaseFactory.instance.getConfigDataSource();
                    String key = ConfigConstants.KEY_CONFIG_STATION_CHECK_REMINDED + stationId;
                    configDataSource.set(key, ConfigConstants.VALUE_NO);

                    //重置进度
                    //当前测回
                    setCurrentCycle(cycleIndex);
                    //所有测回未完成
                    setAllCycleSchedule(SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);
                    //单个测回未完成
                    setSingleCycleSchedule(cycleIndex, SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);
                    //重新测量，并刷新
                    findTargetFromBeginInCurrentCycle(true);
                });
    }

    private static final String KEY_STATION_ID = "__station_id";
    private static final String KEY_PERIOD_INDEX = "__period_index__";

    static Bundle args(String stationId, int periodIndex) {
        Bundle args = new Bundle();
        args.putString(KEY_STATION_ID, stationId);
        args.putInt(KEY_PERIOD_INDEX, periodIndex);
        return args;
    }
}
