package com.bingce.controlnetwork.surveyor.state.alonedistance;

import android.os.Bundle;

import com.bingce.controlapphelper.model.LeftOrRight;
import com.bingce.controlapphelper.surveyor.data.CachedDataAloneDistance;
import com.bingce.controlapphelper.surveyor.data.ICycleRecorder;
import com.bingce.controlapphelper.surveyor.data.ISurveyorData;
import com.bingce.controlapphelper.surveyor.method.FindTargetMethod;
import com.bingce.controlapphelper.surveyor.state.StateType;

/**
 * 移动到一个待测量位置
 * <p>
 * 不会跳转到其他测期
 * <p>
 * 可能涉及转向（盘左->盘右）
 */
class _DoMove2NextValidateState extends __BaseState {

    public _DoMove2NextValidateState(StateManagerAloneDistance stateManager) {
        super(StateType.doMove2NextValidate, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        CachedDataAloneDistance cachedData = getCachedData();
        ISurveyorData surveyorData = getSurveyorData();
        ICycleRecorder cycleRecorder = getCycleRecorder();

        int pointCount = cachedData.pointCount();
        int currentIndex = surveyorData.currentIndex();
        if (currentIndex < 0) {
            currentIndex = 0;
        }
        final int currentCycleIndex = cycleRecorder.currentCycleIndex();
        final LeftOrRight currentSurveyorState = surveyorData.leftOrRight();


        FindTargetMethod.Target needMeasureForAloneDistanceTarget = FindTargetMethod.findNeedMeasureTargetInSingleCycleForAloneDistance(stationId(), currentCycleIndex,
                currentIndex,
                currentSurveyorState,
                pointCount,
                true,
                cachedData);

        if (needMeasureForAloneDistanceTarget != null) {
            navigation2(needMeasureForAloneDistanceTarget.itemIndex, needMeasureForAloneDistanceTarget.leftOrRight);
            return;
        }


        //3.当前测回完成测量，停留状态
        //重置标识
        enterIdleAndClearSurveyorStatePosition();
    }

    /**
     * 跳转到下一目标点
     *
     * @param targetIndex         目标点索引
     * @param targetSurveyorState 测量状态（盘左or盘右）
     */
    private void navigation2(int targetIndex, LeftOrRight targetSurveyorState) {
        //更新测量进度
        setSurveyPosition(targetIndex, targetSurveyorState);
        //清除测量状态，进入idle，但是不停止自动测量
        enterIdleAndClearSurveyStateAndResetAutoMode(false);
        //滚动
        scroll2(targetIndex);
    }
}
