package com.bingce.controlnetwork.surveyor.state.alonedistance;

import android.os.Bundle;

import androidx.annotation.NonNull;

import com.bingce.controlapphelper.datasource.database.SurveyorDatabaseFactory;
import com.bingce.controlapphelper.datasource.database.config.ConfigConstants;
import com.bingce.controlapphelper.datasource.database.config.ConfigRecord;
import com.bingce.controlapphelper.datasource.database.config.IConfigDataSource;
import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.surveyor.state.IAutoModeSwitcher;
import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.controlapphelper.util.Tools;
import com.bingce.controlnetwork.R;
import com.bingce.utils.ThreadPoolUtil;

import net.tatans.tensorflowtts.tts.TtsManager;

/*
 * 检测是否所有 测期都完成了测量
 *
 * 只有在当前测期完成测量之后，才会进入当前状态
 * */
public class _IsAllCycleCompletedState extends __BaseState {
    private final IAutoModeSwitcher autoModeSwitcher;

    public _IsAllCycleCompletedState(@NonNull StateManagerAloneDistance stateManager, IAutoModeSwitcher autoModeSwitcher) {
        super(StateType.isAllCycleCompleted, stateManager);
        this.autoModeSwitcher = autoModeSwitcher;
    }

    @Override
    public void enter(Bundle args) {
        if (isAutoSurveyOpen()) {
            //检测是否已经提示
            //检测是否需要提示测站检测
            IConfigDataSource configDataSource =
                    SurveyorDatabaseFactory.instance.getConfigDataSource();
            ThreadPoolUtil.execute(() -> {
                String key = ConfigConstants.KEY_CONFIG_STATION_CHECK_REMINDED + stationId();
                ConfigRecord record = configDataSource.getByKeySync(key);
                if (record == null || ConfigConstants.VALUE_NO.equals(record.getConfigValue())) {
                    runOnUI(() -> TtsManager.getInstance().speak(Tools.getString(R.string.all_cycle_completed)));
                }
            });
        }
        //标识测站完成测量（数据库存储）
        setAllCycleSchedule(SurveyorScheduleConstants.STATUE_VALUE_COMPLETED);
        //进入idle状态
        //清除测量状态，进入测站检测，停止自动测量
        enterStationCheckAndClearSurveyStateAndResetAutoMode();
    }
}
