package com.bingce.controlnetwork.surveyor.state.angledistance;

import android.os.Bundle;

import com.bingce.controlapphelper.surveyor.state.IAutoModeSwitcher;
import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.controlapphelper.util.Tools;
import com.bingce.controlnetwork.R;
import com.bingce.totalstation.ControlSurveyResult;

import net.tatans.tensorflowtts.tts.TtsManager;

/**
 * 先检测是否有其他未完成测回，继续本次测量将删除其他测回数据
 */
class _DoAutoSurveyorState extends __BaseState {
    private final IAutoModeSwitcher autoModeSwitcher;

    public _DoAutoSurveyorState(StateManager stateManager, IAutoModeSwitcher autoModeSwitcher) {
        super(StateType.doAutoSurveyor, stateManager);
        this.autoModeSwitcher = autoModeSwitcher;
    }

    @Override
    public void enter(Bundle args) {
        if (autoModeSwitcher.isReadyAutoSurvey() == ControlSurveyResult.CODE_SUCCESS) {
            autoModeSwitcher.openAutoMode();
            navigation2(StateType.doMove2NextValidate);
            TtsManager.getInstance().speak(Tools.getString(R.string.start_auto_measure));
        }
    }
}
