package com.bingce.controlnetwork.surveyor.state.angledistance;

import android.os.Bundle;

import com.bingce.controlapphelper.surveyor.method.SurveyorAdjustMethod;
import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.controlnetwork.fragment.StationDataAdjustDialogFragment;

/**
 * 平差计算
 */
public class _DoCalAdjustState extends __BaseState {

    public _DoCalAdjustState(StateManager stateManager) {
        super(StateType.doCalAdjust, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        String showType = null;
        if (args != null) {
            showType = args.getString(StationDataAdjustDialogFragment.KEY_SHOW_TYPE);
        }
        startCalAdjust(showType);
    }

    private void startCalAdjust(String showType) {
        runOnBackground(() -> {
                    SurveyorAdjustMethod.AdjustResult adjustResult = SurveyorAdjustMethod.calStationAdjust(getStation(), getCachedData());
                    if (adjustResult.isError()) {
                        runOnUI(() -> _CheckStationState.showErrorTips(adjustResult.errorString, stationId(), getToleranceRecord().getCycleCount(),
                                getSurveyorData(), getCycleRecorder(), getCachedData(),
                                _DoCalAdjustState.this,
                                fragmentManager(),
                                lifecycleOwner()));
                        return;
                    }
                    //清除测量状态，进入idle，停止自动测量
                    enterIdleAndClearSurveyStateAndResetAutoMode(true);
                    StationDataAdjustDialogFragment.showDialog(showType, adjustResult.result, adjustResult.showSlopDistance, fragmentManager());
                }
        );
    }
}
