package com.bingce.controlnetwork.surveyor.state.heighttraverse;

import android.os.Bundle;

import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.model.LeftOrRight;
import com.bingce.controlapphelper.surveyor.data.ICachedData;
import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.controlnetwork.fragment.stationsurvey.heighttraverse.MeasureHeightTraverseFragment;
import com.bingce.utils.ThreadPoolUtil;

class _DoDeleteCurrentCycleState extends __BaseState {

    private static final String KEY_STATION_ID = "__station_id";
    private static final String KEY_POSITION_FRAGMENT_INDEX = "__period_index__";

    static Bundle args(String stationId, int periodIndex) {
        Bundle args = new Bundle();
        args.putString(KEY_STATION_ID, stationId);
        args.putInt(KEY_POSITION_FRAGMENT_INDEX, periodIndex);
        return args;
    }

    public _DoDeleteCurrentCycleState(int positionFragment, StateManagerHeightTraverse stateManager) {
        super(StateType.doDeleteCurrentCycle, positionFragment, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        String stationId = args.getString(KEY_STATION_ID);
        int positionFragment = args.getInt(KEY_POSITION_FRAGMENT_INDEX);
        String msg;
        if (positionFragment == MeasureHeightTraverseFragment.POSITION_BACK_PAGE) {
            msg = "是否确定删除后视的所有测回数据？";
        } else {
            msg = "是否确定删除前视的所有测回数据？";
        }
        optionTipsWithStandStill(msg,
                () -> deleteSingleCycle(stationId, positionFragment));
    }

    private void deleteSingleCycle(String stationId, int positionFragment) {
        ThreadPoolUtil.execute(() -> {
            ICachedData cachedData = getCachedData();

            int cycleCount = getToleranceRecord().cycleCount;

            for (int cycleIndex = 0; cycleIndex < cycleCount; cycleIndex++) {
                cachedData.deleteSurveyorRecord(stationId, cycleIndex, 0, LeftOrRight.left);
                cachedData.deleteSurveyorRecord(stationId, cycleIndex, 0, LeftOrRight.right);
            }
            //重置学习测量的标志
            resetLearnDataTag();

            //重置所有测回和当次测回进度
            setAllCycleScheduleSync(SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);
            //设置当前测回
            setCurrentCycleSync(0);

            //重新测量，并刷新
            findTargetFromBeginInCurrentCycle(true, 0);

            refreshUI();

//
//            int pointIndex = getCurrentIndex();
//
//
//            FindTargetMethod.Target target = _DoMove2NextValidateState.getTargetAscOrDesc(stationId, pointIndex, cachedData,
//                    false, dataCategory -> !dataCategory.isEmptyData());
//
//            if (target == null) {
//                navigation2(StateType.idle);
//                return;
//            }
//
//            int deleteCycleIndex = target.cycleIndex;
//            //删除数据
//            ICachedData stationSurveyorDataSource = getCachedData();
//            stationSurveyorDataSource.deleteSurveyorRecordSync(stationId, deleteCycleIndex);
//
//            //清除已经提示测站可以检测标识
//            IConfigDataSource configDataSource = SurveyorDatabaseFactory.instance.getConfigDataSource();
//            String key = ConfigConstants.KEY_CONFIG_STATION_CHECK_REMINDED + stationId;
//            configDataSource.setSync(key, ConfigConstants.VALUE_NO);
//
//            if (deleteCycleIndex == 0) {
//                //当第一测回
//                //重置学习测量的标志
//                resetLearnDataTag();
//            }
//
//            //重置所有测回和当次测回进度
//            setAllCycleScheduleSync(SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);
//            setSingleCycleScheduleSync(deleteCycleIndex, SurveyorScheduleConstants.STATUE_VALUE_NO_COMPLETED);
//
//            //设置当前测回
//            setCurrentCycleSync(deleteCycleIndex);
//
//            //重新测量，并刷新
//            findTargetFromBeginInCurrentCycle(true, 0);
        });

    }

}
