package com.bingce.controlnetwork.surveyor.state.heighttraverse;

import android.os.Bundle;

import com.bingce.controlapphelper.datasource.database.schedule.SurveyorScheduleConstants;
import com.bingce.controlapphelper.model.BundleConstants;
import com.bingce.controlapphelper.model.DataCategory;
import com.bingce.controlapphelper.surveyor.method.FindTargetMethod;
import com.bingce.controlapphelper.surveyor.state.StateType;

public class _Init extends __BaseState {

    public _Init(int positionFragment, StateManagerHeightTraverse stateManager) {
        super(StateType.init, positionFragment, stateManager);
    }

    @Override
    public void enter(Bundle args) {

        if (getCachedData().pointCount() == 0) {
            navigation2(StateType.idle);
            return;
        }

        //计算状态之前，重置测量状态
        getSurveyorData().clearSurveyStateAndPosition();

        //1.先查找补测数据
        FindTargetMethod.Target target = lookTarget(dataCategory -> DataCategory.dirtyAndNeedReSurveyor == dataCategory);
        if (target != null) {
            lookTargetAfter(target.itemIndex, target.leftOrRight);
            return;
        }
        //2.查找empty数据
        target = lookTarget(dataCategory -> DataCategory.empty == dataCategory);
        if (target != null) {
            //直接跳转到目标点，开启新测量
            lookTargetAfter(target.itemIndex, target.leftOrRight);
            return;
        }
        //3.
        String error = _CheckStationState._stationCheck(stationId(), getToleranceRecord(), getCachedData());
        if (error.isEmpty()) {
            //设置测量进度(数据库存储)
            setAllCycleSchedule(SurveyorScheduleConstants.STATUE_VALUE_CHECKED);

            //清除测量状态，进入idle，停止自动测量
            enterIdleAndClearSurveyStateAndResetAutoMode(true);
        } else {
            _CheckStationState.showErrorTips(error, stationId(), getToleranceRecord().getCycleCount(),
                    getCachedData(),
                    this,
                    fragmentManager(),
                    lifecycleOwner());
        }
    }

    private FindTargetMethod.Target lookTarget(ILookCase lookCase) {
        return _DoMove2NextValidateState.findTarget(stationId(),
                getCachedData().pointCount(), getCachedData(), 0, true,
                lookCase);
    }

    static void enter(StateManagerHeightTraverse stateManager, int cycleIndex) {
        Bundle args = new Bundle();
        args.putInt(BundleConstants.KEY_CYCLE_INDEX, cycleIndex);
        stateManager.enter(StateType.init, args);
    }
}
