package com.bingce.controlnetwork.surveyor.state.heighttraverse;

import android.os.Bundle;

import com.bingce.controlapphelper.surveyor.state.StateType;
import com.bingce.controlapphelper.util.Tools;
import com.bingce.controlnetwork.R;

/*
 * 仪器导致的测量失败
 *
 * 全站仪多次测量失败，进入该状态
 * */
class _SurveyorFailureState extends __BaseState {

    public _SurveyorFailureState(int positionFragment, StateManagerHeightTraverse stateManager) {
        super(StateType.SurveyorFailure, positionFragment, stateManager);
    }

    @Override
    public void enter(Bundle args) {
        String error = "";
        boolean isShowDialog = true;
        if (args != null) {
            error = args.getString(KEY);
            isShowDialog = args.getBoolean(KEY_IS_SHOW_DIALOG, true);
        }

        if (isShowDialog) {
            failureTipsWithAutoStandStill(error + Tools.getString(R.string.please_observe_target));
        } else {
            enterIdleAndClearSurveyStateAndResetAutoMode(true);
        }

    }

    private static final String KEY = "error";
    private static final String KEY_IS_SHOW_DIALOG = "KEY_IS_SHOW_DIALOG";

    public static Bundle args(String error) {
        Bundle args = new Bundle();
        args.putString(KEY, error);
        return args;
    }

    public static Bundle args(String error, boolean isShowDialog) {
        Bundle args = new Bundle();
        args.putString(KEY, error);
        args.putBoolean(KEY_IS_SHOW_DIALOG, isShowDialog);
        return args;
    }
}
