package com.bingce.controlnetwork.surveyor.surveyor;

import android.app.Dialog;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.FragmentManager;
import androidx.recyclerview.widget.RecyclerView;

import com.bingce.controlapphelper.surveyor.test.Test;

import org.jetbrains.annotations.NotNull;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.adapter.IndexWithTextAdapter;
import com.bingce.controlnetwork.adapter.IndexWithTextAdapter;

public class TestDataSelectFragment extends DialogFragment {

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_single_list_layout, container, false);

        // Set the adapter
        if (view instanceof RecyclerView) {
            RecyclerView recyclerView = (RecyclerView) view;
            refreshRecyclerView(recyclerView);
        }

        return view;
    }

    @Override
    public void onViewCreated(@NonNull @NotNull View view, @Nullable @org.jetbrains.annotations.Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Dialog dialog = getDialog();
        if (dialog == null) {
            return;
        }
        Window window = dialog.getWindow();
        if (window == null) {
            return;
        }
        window.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT);
        WindowManager.LayoutParams lps = window.getAttributes();
        lps.verticalMargin = 0.4F;
        lps.horizontalMargin = 0.4F;
        window.setAttributes(lps);
    }

    protected void refreshRecyclerView(RecyclerView recyclerView) {
        IndexWithTextAdapter<Test.Item> adapter = new IndexWithTextAdapter<>(Test.items, new IndexWithTextAdapter.IOnItemClick<Test.Item>() {
            @Override
            public void onItemClick(Test.Item item) {
                Test.type = item;
                dismiss();
            }
        });
        recyclerView.setAdapter(adapter);
    }

    public static void show(FragmentManager fragmentManager) {
        TestDataSelectFragment fragment = new TestDataSelectFragment();
        fragment.show(fragmentManager, TestDataSelectFragment.class.getName());
    }
}
