package com.bingce.controlnetwork.ui.vh;

import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bingce.controlapphelper.model.StationDetailItem;

import com.bingce.controlnetwork.R;

public class DraggableTextViewHolder extends RecyclerView.ViewHolder {
    public final TextView title;
    public final ImageView dragBar;

    public DraggableTextViewHolder(@NonNull View itemView) {
        super(itemView);
        title = itemView.findViewById(R.id.title);
        dragBar = itemView.findViewById(R.id.drag_bar);
    }

    public static void update(DraggableTextViewHolder draggableTextViewHolder, StationDetailItem item, boolean editable) {
        draggableTextViewHolder.title.setText(item.getName());
        if (StationDetailItem.ITEM_TYPE_STATION_ITEM.equals(item.getType()) || !editable) {
            draggableTextViewHolder.dragBar.setVisibility(View.GONE);
        } else {
            draggableTextViewHolder.dragBar.setVisibility(View.VISIBLE);
        }
    }
}