package com.bingce.controlnetwork.ui.vh;

import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bingce.controlapphelper.model.StationDetailItem;

import com.bingce.controlnetwork.R;

public class ItemWellViewHolder extends RecyclerView.ViewHolder {
    public final TextView title;
    public final ImageView dragBar;

    public ItemWellViewHolder(@NonNull View itemView) {
        super(itemView);
        title = itemView.findViewById(R.id.title);
        dragBar = itemView.findViewById(R.id.drag_bar);
    }

    public static void update(ItemWellViewHolder holder, StationDetailItem item, boolean editable, IUIBuilderDelegate iuiBuilderDelegate) {
        holder.title.setText(item.getName());
        if (StationDetailItem.ITEM_TYPE_STATION_ITEM.equals(item.getType()) || !editable) {
            holder.dragBar.setVisibility(View.GONE);
        } else {
            holder.dragBar.setVisibility(View.VISIBLE);
        }

        if (iuiBuilderDelegate != null) {
            iuiBuilderDelegate.build(item.getType(), holder);
        }
    }

    public interface IUIBuilderDelegate {
        void build(String itemType, ItemWellViewHolder holder);
    }
}