package com.bingce.controlnetwork.ui.vh;

import android.view.View;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bingce.controlapphelper.model.StationDetailItem;

import org.jetbrains.annotations.NotNull;

import com.bingce.controlnetwork.R;

public class StationGroupItemViewHolder extends RecyclerView.ViewHolder {
    public final TextView title;
    public final View pick;
    public final View switchView;

    public StationGroupItemViewHolder(@NonNull @NotNull View itemView) {
        super(itemView);
        title = itemView.findViewById(R.id.groupName);
        pick = itemView.findViewById(R.id.pick_station_point);
        switchView = itemView.findViewById(R.id.switch_station_point);
    }

    public static void update(StationGroupItemViewHolder surveyorStationSetupGroupParentViewHolder,
                              StationDetailItem item,
                              boolean adjustable,
                              IUIBuilderDelegate builderDelegate) {
        surveyorStationSetupGroupParentViewHolder.title.setText(item.getName());
        //判断是否需要un enable添加按钮
        if (!adjustable) {
            surveyorStationSetupGroupParentViewHolder.pick.setVisibility(View.GONE);
            surveyorStationSetupGroupParentViewHolder.switchView.setVisibility(View.GONE);
        } else {
            if (builderDelegate != null) {
                builderDelegate.build(item.getType(), surveyorStationSetupGroupParentViewHolder);
            }
        }
    }

    public interface IUIBuilderDelegate {
        void build(String itemType, StationGroupItemViewHolder surveyorStationSetupGroupParentViewHolder);
    }
}
