package com.bingce.controlnetwork.ui.widget;

import android.content.Context;
import android.content.res.TypedArray;
import android.util.AttributeSet;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bingce.controlnetwork.R;

public class TextItemWithDescribe extends TextItem {
    public TextItemWithDescribe(@NonNull Context context) {
        super(context);
    }

    public TextItemWithDescribe(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    public TextItemWithDescribe(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public TextItemWithDescribe(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
    }

    @Override
    void init(Context context, AttributeSet attrs) {
        super.init(context, attrs);
        String describe = "";
        if (attrs != null) {
            final TypedArray a = context.obtainStyledAttributes(attrs, R.styleable.TextItemWithDescribe);
            describe = a.getString(R.styleable.TextItemWithDescribe_describeValue);
            a.recycle();
        }
        setDescribeText(describe);
    }

    @Override
    protected int contentLayout() {
        return super.contentLayout();
    }

    public void setDescribeText(String text) {
        TextView describe = findViewById(R.id.describe);
        if (describe != null) {
            if (text == null || text.isEmpty()) {
                describe.setVisibility(GONE);
            } else {
                describe.setVisibility(VISIBLE);
                describe.setText(text);
            }
        }
    }
}
