package com.bingce.controlnetwork.ui.widget;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.recyclerview.widget.RecyclerView;

import com.bingce.controlapphelper.model.ViewItemType;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.ui.vh.DraggableTextViewHolder;
import com.bingce.controlnetwork.ui.vh.GroupParentViewHolder;
import com.bingce.controlnetwork.ui.vh.IndexTextSelectableViewHolder;
import com.bingce.controlnetwork.ui.vh.IndexTextViewHolder;
import com.bingce.controlnetwork.ui.vh.IndexTextWithPrefixViewHolder;
import com.bingce.controlnetwork.ui.vh.ItemWellViewHolder;
import com.bingce.controlnetwork.ui.vh.KeyBoolViewHolder;
import com.bingce.controlnetwork.ui.vh.KeyValueViewHolder;
import com.bingce.controlnetwork.ui.vh.StationAdjustItemViewHolder;
import com.bingce.controlnetwork.ui.vh.StationGroupItemViewHolder;
import com.bingce.controlnetwork.ui.vh.SurveyorDataAloneDistanceViewHolder;
import com.bingce.controlnetwork.ui.vh.SurveyorDataViewHolder;
import com.bingce.controlnetwork.ui.vh.SurveyorDataViewHolderHeightTraverse;
import com.bingce.controlnetwork.ui.vh.TextSelectableViewHolder;
import com.bingce.controlnetwork.ui.vh.TitleWithSubtitleViewHolder;
import com.bingce.controlnetwork.ui.vh.DraggableTextViewHolder;
import com.bingce.controlnetwork.ui.vh.GroupParentViewHolder;
import com.bingce.controlnetwork.ui.vh.IndexTextSelectableViewHolder;
import com.bingce.controlnetwork.ui.vh.IndexTextViewHolder;
import com.bingce.controlnetwork.ui.vh.IndexTextWithPrefixViewHolder;
import com.bingce.controlnetwork.ui.vh.ItemWellViewHolder;
import com.bingce.controlnetwork.ui.vh.KeyBoolViewHolder;
import com.bingce.controlnetwork.ui.vh.KeyValueViewHolder;
import com.bingce.controlnetwork.ui.vh.StationAdjustItemViewHolder;
import com.bingce.controlnetwork.ui.vh.StationGroupItemViewHolder;
import com.bingce.controlnetwork.ui.vh.SurveyorDataAloneDistanceViewHolder;
import com.bingce.controlnetwork.ui.vh.SurveyorDataViewHolder;
import com.bingce.controlnetwork.ui.vh.SurveyorDataViewHolderHeightTraverse;
import com.bingce.controlnetwork.ui.vh.TextSelectableViewHolder;
import com.bingce.controlnetwork.ui.vh.TitleWithSubtitleViewHolder;


public class ViewFactory {

    //生成对应的配置view
    public static View generatorView(Context context, ViewGroup parent, ViewItemType viewType) {
        switch (viewType) {
            case indexWithName:
                return LayoutInflater.from(context).inflate(R.layout.list_item_index_text_layout, parent, false);
            case indexWithNameAndPrefix:
                return LayoutInflater.from(context).inflate(R.layout.list_item_index_text_with_prefix_layout, parent, false);
            case indexWithNameSelectable:
                return LayoutInflater.from(context).inflate(R.layout.list_item_index_text_selectable_layout, parent, false);
            case groupParent:
                return LayoutInflater.from(context).inflate(R.layout.list_item_group_parent_layout, parent, false);
            case nameWithText:
                return LayoutInflater.from(context).inflate(R.layout.list_item_text_value_layout, parent, false);
            case nameWithBool:
                return LayoutInflater.from(context).inflate(R.layout.list_item_text_boolen_layout, parent, false);
            case titleWithSubtitle:
                return LayoutInflater.from(context).inflate(R.layout.list_item_title_subtitle_layout, parent, false);
            case draggableItem:
                return LayoutInflater.from(context).inflate(R.layout.list_item_draggable_layout, parent, false);
            case surveyorStationCreateStationGroupItem:
                return LayoutInflater.from(context).inflate(R.layout.list_item_surveyor_station_group_parent_with_add_layout, parent, false);
            case textSelectable:
                return LayoutInflater.from(context).inflate(R.layout.list_item_text_selectable_layout, parent, false);
            case surveyorStationPointItem:
                return LayoutInflater.from(context).inflate(R.layout.list_item_surveyor_station_point_layout, parent, false);
            case stationAdjust:
                return LayoutInflater.from(context).inflate(R.layout.list_item_station_adjust_layout, parent, false);
            case wellItem:
                return LayoutInflater.from(context).inflate(R.layout.list_item_well, parent, false);
            case aloneDistanceMeasure:
                return LayoutInflater.from(context).inflate(R.layout.list_item_well_measure_distance, parent, false);
            case heightTraverseSurveyor:
                return LayoutInflater.from(context).inflate(R.layout.list_item_surveyor_station_height_traverse, parent, false);
            default:
                return null;
        }
    }

    public static RecyclerView.ViewHolder generatorViewHolder(Context context, ViewGroup parent, ViewItemType viewType) {
        View view = generatorView(context, parent, viewType);
        if (view == null) {
            return null;
        }
        switch (viewType) {
            case indexWithName:
                return new IndexTextViewHolder(view);
            case indexWithNameAndPrefix:
                return new IndexTextWithPrefixViewHolder(view);
            case indexWithNameSelectable:
                return new IndexTextSelectableViewHolder(view);
            case groupParent:
                return new GroupParentViewHolder(view);
            case nameWithText:
                return new KeyValueViewHolder(view);
            case nameWithBool:
                return new KeyBoolViewHolder(view);
            case titleWithSubtitle:
                return new TitleWithSubtitleViewHolder(view);
            case draggableItem:
                return new DraggableTextViewHolder(view);
            case surveyorStationCreateStationGroupItem:
                return new StationGroupItemViewHolder(view);
            case textSelectable:
                return new TextSelectableViewHolder(view);
            case surveyorStationPointItem:
                return new SurveyorDataViewHolder(context, view);
            case stationAdjust:
                return new StationAdjustItemViewHolder(view);
            case wellItem:
                return new ItemWellViewHolder(view);
            case aloneDistanceMeasure:
                return new SurveyorDataAloneDistanceViewHolder(context, view);
            case heightTraverseSurveyor:
                return new SurveyorDataViewHolderHeightTraverse(context, view);
            default:
                return null;
        }
    }
}
