package com.bingce.controlnetwork.ui.widget.dialog;

import android.content.Context;

import androidx.annotation.MainThread;

public class LoadingUtil {
    private static LoadingDialog loadingDialog;

    @MainThread
    public static void show(Context context, String msg) {
        LoadingDialog.Builder loadBuilder = new LoadingDialog.Builder(context)
                .setMessage(msg)
                .setCancelable(true)//返回键是否可点击
                .setCancelOutside(false);//窗体外是否可点击
        loadingDialog = loadBuilder.create();
        loadingDialog.show();
    }

    @MainThread
    public static void dismiss() {
        try {
            if (loadingDialog != null && loadingDialog.isShowing()) {
                loadingDialog.dismiss();
            }
            loadingDialog = null;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
