package com.bingce.controlnetwork.ui.widget.recyclerview;

public interface IDragSwipeActionListener {
    /**
     * 左右滑动删除操作
     *
     * @param adapterPosition --被滑动的item索引
     */
    void onItemSwiped(int adapterPosition);

    /**
     * 上下拖拽操作进行中，没有完成，用户手指还没离开屏幕
     *
     * @param from 被拖拽item原来索引
     * @param to   被拖拽item目标索引
     */
    void onItemDragging(int from, int to);

    /**
     * 上下拖拽操作完成，用户手指离开屏幕
     */
    void onItemDragCompleted();
}
