package com.bingce.controlnetwork.ui.widget.treeview.custom;

import android.view.View;
import android.widget.Checkable;
import android.widget.TextView;

import com.bingce.controlnetwork.R;
import com.bingce.controlnetwork.ui.widget.treeview.base.CheckableNodeViewBinder;
import com.bingce.controlnetwork.ui.widget.treeview.TreeNode;
import com.bingce.controlnetwork.ui.widget.treeview.base.CheckableNodeViewBinder;

/**
 * Created by zxy on 17/4/23.
 */

public class ThirdLevelNodeViewBinder extends CheckableNodeViewBinder {
    TextView textView;

    public ThirdLevelNodeViewBinder(View itemView) {
        super(itemView);
        textView = itemView.findViewById(R.id.node_name_view);
    }

    @Override
    public int getCheckableViewId() {
        return R.id.checkBox;
    }

    @Override
    public void bindView(TreeNode treeNode) {
        textView.setText(treeNode.getValue().getValue().toString());
    }

    @Override
    public void onNodeToggled(TreeNode treeNode, boolean expand) {
        final View view = itemView.findViewById(getCheckableViewId());
        if (view instanceof Checkable && treeNode.isEnable()) {
            final Checkable checkableView = (Checkable) view;
            checkableView.setChecked(!checkableView.isChecked());
            treeNode.setSelected(checkableView.isChecked());
        }
    }
}
