package com.bingce.controlnetwork.util;

import android.app.Activity;
import android.content.Context;

import androidx.appcompat.app.AlertDialog;

import com.bingce.AppChannel;
import com.bingce.BaseApp;
import com.bingce.data.sync.utils.LeanCloudConfigLoader;
import com.bingce.utils.StringUtil;
import com.bingce.utils.UpdateUtils;

import blankj.utilcode.util.AppUtils;
import blankj.utilcode.util.Utils;

import com.bingce.controlnetwork.R;

public class CheckControlUpdateUtil {
    public static void checkUpdate(Context context, boolean forceShow) {
        String queryUrl = "latestVersionCodeUrlControl";
        if (AppChannel.customChannel == AppChannel.CUSTOM_CONTROL_PRO) {
            queryUrl = "latestVersionCodeUrlControlPro";
        }
        LeanCloudConfigLoader.findInBackground(queryUrl, instance -> {
//        new LCQuery<>("Configuration")
//                .whereEqualTo("name", queryUrl)
//                .limit(1)
//                .findInBackground().subscribe(new Observer<List<LCObject>>() {
//                    @Override
//                    public void onSubscribe(Disposable d) {
//
//                    }
//
//                    @Override
//                    public void onNext(List<LCObject> avObjects) {
            if (context instanceof Activity && ((Activity) context).isFinishing()) return;
            if (/*avObjects != null && !avObjects.isEmpty() && avObjects.get(0).getString("value") != null*/instance != null && StringUtil.isNotEmpty(instance.value)) {
                String latestVersionCodeUrl = /*avObjects.get(0).getString("value")*/instance.value;
                String updateLog = /*avObjects.get(0).getString("value2")*/instance.value2;
                String specialVersions = instance.value3;
                boolean isInSpecialVersions = false;
                if (StringUtil.isNotEmpty(specialVersions)) {
                    String[] versionArr = specialVersions.split(",", -2);
                    int currentVersionCode = AppUtils.getAppVersionCode();
                    for (String s : versionArr) {
                        String[] subVersionArr = s.split("-", -2);
                        if (subVersionArr.length == 2) {
                            int v1 = Integer.parseInt(subVersionArr[0]);
                            int v2 = Integer.parseInt(subVersionArr[1]);
                            if (currentVersionCode >= v1 && currentVersionCode <= v2) {
                                isInSpecialVersions = true;
                                break;
                            }
                        }
                    }
                }
                String[] arr = latestVersionCodeUrl.split(",", -2);
                if (arr.length == 2 && updateLog != null && arr[1].endsWith(".apk")) {
                    try {
                        if (isInSpecialVersions) {
                            UpdateUtils.getInstance().showUpdate(context, updateLog, arr[0], arr[1], forceShow);
                        } else {
                            if (forceShow) {
                                if (Integer.parseInt(arr[0]) > AppUtils.getAppVersionCode()) {
                                    UpdateUtils.getInstance().showUpdate(context, updateLog, arr[0], arr[1], forceShow);
                                } else {
                                    new AlertDialog.Builder(context)
                                            .setTitle(R.string.hint)
                                            .setMessage(R.string.already_the_latest_version)
                                            .setPositiveButton(R.string.close, null)
                                            .show();
                                }
                            } else {
                                if (Integer.parseInt(arr[0]) > AppUtils.getAppVersionCode() && Integer.parseInt(arr[0]) > ((BaseApp) Utils.getApp()).ignoredVersionCode) {
                                    UpdateUtils.getInstance().showUpdate(context, updateLog, arr[0], arr[1], forceShow);
                                }
                            }
                        }
                    } catch (Exception ignored) {
                    }
                }
            }
//                    }
//
//                    @Override
//                    public void onError(Throwable e) {
//                        emergency();//后门，防止leancloud崩溃时会员无法登录
//                    }
//
//                    @Override
//                    public void onComplete() {
//
//                    }
        });
    }
}
