package com.bingce.controlnetwork.util;

import static com.bingce.utils.RegisterUtil.getOriginalMachineCode;

import android.Manifest;
import android.content.pm.PackageManager;
import android.os.Build;

import androidx.core.content.ContextCompat;

import com.bingce.AppChannel;
import com.bingce.BaseApp;
import com.bingce.utils.ActivateUtil;
import com.bingce.utils.AppUtil;

import blankj.utilcode.util.Utils;

public class CheckRegUtil {
    /**
     * 检查注册码是否有效，仅限offline调用
     *
     * @return
     * @reg_code 激活码
     */
    public static boolean checkReg(String reg_code) {
        if (!((BaseApp) Utils.getApp()).userAgreementAgree)
            return false;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O && Build.VERSION.SDK_INT < Build.VERSION_CODES.Q) {//Q=10,大于安卓10的可能是手薄，不需要检测电话权限
            if (ContextCompat.checkSelfPermission(Utils.getApp(), Manifest.permission.READ_PHONE_STATE) != PackageManager.PERMISSION_GRANTED) {
//                ToastUtils.showShort("为了认证激活信息，请打开读取手机状态权限");
                return false;
            }
        }
        if (AppChannel.customChannel != AppChannel.CUSTOM_INTERNATIONAL
                && AppChannel.customChannel != AppChannel.CUSTOM_TERSUS_INTERNATIONAL
                && AppChannel.customChannel != AppChannel.CUSTOM_PENTAX_INTERNATIONAL
                && AppChannel.customChannel != AppChannel.CUSTOM_SURVEY_SPACE_INTERNATIONAL
                && AppChannel.customChannel != AppChannel.CUSTOM_TUNNEL_AUTO_SCAN) {
            if (!AppUtil.isZhCN())//国内发行版本在非简体中文语言下不可用
                return false;
        }
        if ("".equals(getOriginalMachineCode())
                || "SERIALNUMBERunknown".equals(getOriginalMachineCode())
                || "SERIALNUMBERnull".equals(getOriginalMachineCode())
                || "SERIALNUMBER".equals(getOriginalMachineCode())) {
            return false;
        }
        //开始验证
        String machineCode = getOriginalMachineCode();
        String answer;
        if (machineCode != null) {
            answer = "";
            String md5 = ActivateUtil.encrypt(Utils.getApp(), machineCode, AppChannel.customChannel);
            if (md5 != null) {
                for (int i = 0; i < md5.length(); i++) {
                    if (i % 2 == 1)
                        answer += md5.charAt(i);
                }
                answer = answer.toUpperCase();
                return reg_code.equals(answer);
            } else {//如果返回null，说明破解打包了
                return false;
            }
        }
        return false;
    }
}
