package com.bingce.controlnetwork.util;

import android.content.Intent;
import android.view.View;

import com.afollestad.materialdialogs.MaterialDialog;
import com.bingce.AppChannel;
import com.bingce.controlnetwork.R;
import com.bingce.device.ui.ConnectLevelActivity;
import com.bingce.device.ui.ConnectTSActivity;

import blankj.utilcode.util.ActivityUtils;

public class SelectDeviceTypeUtil {
    public static void showDeviceTypeDialog() {
        new MaterialDialog.Builder(ActivityUtils.getTopActivity())
                .title(R.string.choose_instrument_type)
                .items(new String[]{ActivityUtils.getTopActivity().getString(R.string.total_station), ActivityUtils.getTopActivity().getString(R.string.device_type_level)})
                .itemsCallback(new MaterialDialog.ListCallback() {
                    @Override
                    public void onSelection(MaterialDialog dialog, View itemView, int which, CharSequence text) {
                        switch (which) {
                            case 0:
                                connectTsActivity();
                                break;
                            case 1:
                                connectLevelActivity();
                                break;
                        }
                    }
                }).show();
    }

    public static void connectTsActivity() {
        Intent intent = new Intent(ActivityUtils.getTopActivity(), ConnectTSActivity.class);
        intent.putExtra("customChannel", AppChannel.customChannel);
        ActivityUtils.getTopActivity().startActivity(intent);
    }

    public static void connectLevelActivity() {
        Intent intent2 = new Intent(ActivityUtils.getTopActivity(), ConnectLevelActivity.class);
        intent2.putExtra("customChannel", AppChannel.customChannel);
        ActivityUtils.getTopActivity().startActivity(intent2);
    }


}
