package com.bingce.controlnetwork.util;

import com.bingce.controlapphelper.datasource.database.prism.PrismConstants;
import com.bingce.controlapphelper.datasource.database.surveyorstation.model.SurveyorPoint;

/**
 * 测量转换工具类
 */
public class SurveyorOpenAtrUtil {

    public static boolean isOpenAtr(SurveyorPoint surveyorPoint) {
        return isOpenAtr(surveyorPoint.getPrismType(), surveyorPoint.getPrismTypeLarge()) && !surveyorPoint.isOpenAtrNot();
    }

    public static boolean isOpenAtr(int prismType, String prismTypeLarge) {
        switch (prismType) {
            case PrismConstants.TYPE_PRISM_ROUND:
            case PrismConstants.TYPE_PRISM_MINI:
                return true;
            case PrismConstants.TYPE_USER:
                return PrismConstants.TYPE_PRISM_LARGE.equals(prismTypeLarge);
            default:
                return false;
        }
    }

}
