package com.bingce.controlnetwork.util.config;

import java.util.LinkedHashMap;
import java.util.Map;

public abstract class AbstractSetConfigs {
    private final Map<Integer, ConfigItem> list = new LinkedHashMap<>();

    protected AbstractSetConfigs() {
    }

    public void foreach(IConfigItemCallback callback) {
        if (callback == null) {
            return;
        }
        for (ConfigItem configItem : list.values()) {
            callback.on(configItem);
        }
    }

    public ConfigItem get(int id) {
        return list.get(id);
    }

    public String allIds() {
        return ConfigItem.ids(list.values());
    }

    public String defaultIds() {
        return allIds();
    }

//    private static AbstractSetConfigs instance = null;
//
//    public static AbstractSetConfigs getInstance() {
//        synchronized (ParameterSetConfigs.class) {
//            if (instance == null) {
//                instance = new ParameterSetConfigs();
//                init();
//            }
//        }
//        return instance;
//    }

    public void init() {
        init(list);
    }

    protected abstract void init(final Map<Integer, ConfigItem> list);// {
//        list.put(99, new ConfigItem(99, R.string.road_project_management, R.mipmap.icon_parameter_road_project, DragIconInfo.CATEGORY_ONLY));
//        list.put(100, new ConfigItem(100, R.string.road_parameter, R.mipmap.icon_parameter_road, DragIconInfo.CATEGORY_ONLY));
//        list.put(101, new ConfigItem(101, R.string.break_chain, R.mipmap.icon_parameter_breakchain, DragIconInfo.CATEGORY_ONLY));
//        list.put(102, new ConfigItem(102, R.string.hor_parameter, R.mipmap.icon_parameter_hor, DragIconInfo.CATEGORY_ONLY));
//        list.put(103, new ConfigItem(103, R.string.ver_parameter, R.mipmap.icon_parameter_ver, DragIconInfo.CATEGORY_ONLY));
//        list.put(104, new ConfigItem(104, R.string.standard_cross_section, R.mipmap.icon_parameter_stand_cross_section, DragIconInfo.CATEGORY_ONLY));
//        list.put(105, new ConfigItem(105, R.string.super_elevation, R.mipmap.icon_parameter_super, DragIconInfo.CATEGORY_ONLY));
//        list.put(106, new ConfigItem(106, R.string.widen_change, R.mipmap.icon_parameter_widen, DragIconInfo.CATEGORY_ONLY));
//        list.put(107, new ConfigItem(107, R.string.tunnel_section_library, R.mipmap.icon_parameter_tunnel_section_library, DragIconInfo.CATEGORY_ONLY));
//        list.put(108, new ConfigItem(108, R.string.tcs_matching, R.mipmap.icon_parameter_tunnel_section_matching, DragIconInfo.CATEGORY_ONLY));
//        list.put(109, new ConfigItem(109, R.string.middle_line_offset, R.mipmap.icon_parameter_middle_line_offset, DragIconInfo.CATEGORY_ONLY));
//        list.put(110, new ConfigItem(110, R.string.subway_center_up_down, R.mipmap.icon_parameter_subway_updown, DragIconInfo.CATEGORY_ONLY));
//        list.put(111, new ConfigItem(111, R.string.tcs_feature_point, R.mipmap.icon_parameter_tunnel_feanture_points, DragIconInfo.CATEGORY_ONLY));
//        list.put(112, new ConfigItem(112, R.string.tunnel_embedded_part, R.mipmap.icon_parameter_tunnel_embedded_part, DragIconInfo.CATEGORY_ONLY));
//        list.put(113, new ConfigItem(113, R.string.tcs_rotate, R.mipmap.icon_parameter_tunnel_rotate, DragIconInfo.CATEGORY_ONLY));
//        list.put(114, new ConfigItem(114, R.string.control_point, R.mipmap.icon_parameter_points, DragIconInfo.CATEGORY_ONLY));
//        list.put(115, new ConfigItem(115, R.string.side_section_library, R.mipmap.icon_parameter_side_library, DragIconInfo.CATEGORY_ONLY));
//        list.put(116, new ConfigItem(116, R.string.scs_matching, R.mipmap.icon_parameter_side_section_matching, DragIconInfo.CATEGORY_ONLY));
//        list.put(117, new ConfigItem(117, R.string.subway_common_parameters, R.mipmap.icon_parameter_subway_common_parameters, DragIconInfo.CATEGORY_ONLY));
//        list.put(118, new ConfigItem(118, R.string.tbm_reference_point, R.mipmap.icon_parameter_subway_tbm_reference_point, DragIconInfo.CATEGORY_ONLY));
//        list.put(119, new ConfigItem(119, R.string.staking_point_library, R.mipmap.icon_parameter_staking_point_library, DragIconInfo.CATEGORY_ONLY));
//        list.put(120, new ConfigItem(120, R.string.point_survey_point_library, R.mipmap.icon_program_point_survey, DragIconInfo.CATEGORY_ONLY));
//        list.put(121, new ConfigItem(121, R.string.pier_template_library, R.mipmap.icon_parameter_pier_template_library, DragIconInfo.CATEGORY_ONLY));
//        list.put(122, new ConfigItem(122, R.string.bridge_and_layout, R.mipmap.icon_parameter_pier_layout, DragIconInfo.CATEGORY_ONLY));
//        if (AppChannel.customChannel == AppChannel.CUSTOM_ZJYGJ) {
//            list.put(123, new ConfigItem(123, R.string.menu_item_zjygj_project_list, R.mipmap.icon_road_project_list_zjygj, DragIconInfo.CATEGORY_ONLY));
//        }
//    }

//    public abstract void onItemClick(int id, Fragment fragment);
}
