package com.bingce.controlnetwork.util.config;

import android.content.Context;

import com.wedcel.dragexpandgrid.model.DragIconInfo;

import java.util.ArrayList;
import java.util.Collection;

public class ConfigItem {
    public ConfigItem(int id, int title, int icon, int category) {
        this.id = id;
        this.title = title;
        this.icon = icon;
        this.category = category;
    }

    private int id;
    private int title;
    private int icon;
    int category;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getTitle() {
        return title;
    }

    public void setTitle(int title) {
        this.title = title;
    }

    public int getIcon() {
        return icon;
    }

    public void setIcon(int icon) {
        this.icon = icon;
    }

    public int getCategory() {
        return category;
    }

    public void setCategory(int category) {
        this.category = category;
    }

    private static int readStringResId(Context context, String name) {
        return context.getResources().getIdentifier(name, "string", context.getPackageName());
    }

    private static int readMipmapResId(Context context, String name) {
        return context.getResources().getIdentifier(name, "mipmap", context.getPackageName());
    }

    private static String readStringValue(Context context, String name) {
        return context.getString(readStringResId(context, name));
    }

    public DragIconInfo convert(Context context) {
        return new DragIconInfo(
                getId(),
                context.getString(getTitle()),
                getIcon(),
                DragIconInfo.CATEGORY_ONLY,
                false,
                new ArrayList<>());
    }

    public static String ids(Collection<ConfigItem> list) {
        StringBuilder builder = new StringBuilder();
        for (ConfigItem item : list) {
            builder
                    .append(item.getId())
                    .append(",");
        }
        return builder.toString();
    }
}
