package com.bingce.controlnetwork.util.tolerance

import com.bingce.controlapphelper.datasource.database.leveling.LevelingDbFactory
import com.bingce.controlapphelper.datasource.database.leveling.tolerance.LevelingToleranceDetail
import com.bingce.controlapphelper.datasource.database.tolerance.detail.IToleranceDetail
import com.bingce.controlapphelper.datasource.database.tolerance.group.ToleranceGroupRecord
import com.bingce.controlapphelper.datasource.database.tolerance.level.ToleranceLevelRecord
import com.bingce.controlapphelper.datasource.database.tolerance.load.IToleranceOperate
import com.bingce.controlapphelper.datasource.database.tolerance.load.ToleranceLoadUtil
import com.bingce.utils.IOnSingleGetCallback

class LevelToleranceOperate : IToleranceOperate {
    override fun getIToleranceDetail(id: String): IToleranceDetail? {
        return LevelingDbFactory.instance
            .getToleranceDetailDataSource().getRecordSync(id)
    }

    override fun saveToleranceDetail(bean: IToleranceDetail?) {
        bean?.let {
            LevelingDbFactory.instance
                .getToleranceDetailDataSource().saveWithCallback(it as LevelingToleranceDetail) {

                }
        }
    }

    override fun getGroup(itoleranceDetail: IToleranceDetail): ToleranceGroupRecord? {
        return ToleranceLoadUtil.getLevelToleranceLoad().groupOf(itoleranceDetail.groupId)
    }

    override fun getLevel(itoleranceDetail: IToleranceDetail): ToleranceLevelRecord? {
        return ToleranceLoadUtil.getLevelToleranceLoad().levelOf(itoleranceDetail.levelId)
    }

    override fun getDefaultRecord(callback: IOnSingleGetCallback<IToleranceDetail?>) {
        LevelingDbFactory.instance
            .getToleranceDetailDataSource().getDefaultRecord(callback)
    }

}