package com.bingce

import org.gradle.api.Project
import java.io.File
import java.io.FileInputStream
import java.util.Properties

class BcFolder(project: Project) {
    private val NAME = "local.properties"
    private val properties: Properties = Properties()
    private val rootProject = project.rootProject

    init {
        val config1 = File(rootProject.projectDir.parent, NAME)
        if (config1.exists()) {
            properties.load(FileInputStream(config1))
        } else {
            properties.load(FileInputStream(project.rootProject.file(NAME)))
        }
    }

    fun rootProjectDir(): File {
        val bcFolder = properties.getProperty("bingce.dir")
        if (bcFolder == null || bcFolder.isEmpty()) return rootProject.projectDir

        return File(bcFolder)
    }

    fun folderConfig(folderKey: String): File? {
        val folderString = properties.getProperty(folderKey)
        if (folderString == null || folderString.isEmpty()) return null
        return File(folderString)
    }
}