package com.bingce

import org.gradle.api.Project
import java.io.File
import java.io.FileInputStream
import java.util.Properties

class ConfigProperties(project: Project) {
    private val NAME = "local.properties"
    private val properties: Properties = Properties()

    init {
        val rootProject = project.rootProject
        val config1 = File(rootProject.projectDir.parent, NAME)
        if (config1.exists()) {
            properties.load(FileInputStream(config1))
        } else {
            properties.load(FileInputStream(project.rootProject.file(NAME)))
        }
    }

    fun getProperty(key: String?): String? {
        return properties.getProperty(key)
    }
}