package com.bingce

import org.gradle.api.Project
import java.io.FileInputStream
import java.util.*

class ModuleName(project: Project) {
    private val useAAR: String
    private val useBaseAAR: String
    private val useDeviceAAR: String

    init {
        val properties = ConfigProperties(project)
        useAAR = properties.getProperty("useAAR") ?: "true"
        useBaseAAR = properties.getProperty("useBaseAAR") ?: "true"
        useDeviceAAR = properties.getProperty("useDeviceAAR") ?: "true"
    }

    fun bingceModule(name: String): String {
        if (listOf(
                "base"
            ).contains(name)
        ) {
            return if ("false" == useBaseAAR) {
                ":bingce:${name}"
            } else {
                ":aar:${name}"
            }
        }

        if (listOf(
                "level", "rtk", "totalstation"
            ).contains(name)
        ) {
            return if ("false" == useDeviceAAR) {
                ":bingce:${name}"
            } else {
                ":aar:${name}"
            }
        }

        return if ("false" == useAAR) {
            ":bingce:$name"
        } else {
            ":aar:$name"
        }
    }

    fun openSourceModule(name: String): String {
        return if ("false" == useAAR) {
            ":opensource:$name"
        } else {
            ":aar:$name"
        }
    }

    fun isUseAAR(): Boolean {
        return useAAR == "true"
    }
}