package com.bingce

import org.gradle.api.Project
import java.util.Calendar

class SurveyorVersionUtils(project: Project) {
    val versionCode: Int
    val versionName: String
    val mappingFolder: String

    init {
        val cale = Calendar.getInstance();
        val year = cale.get(Calendar.YEAR);
        val month = cale.get(Calendar.MONTH) + 1;
        val day = cale.get(Calendar.DATE);
        val hour = cale.get(Calendar.HOUR_OF_DAY);
        val minute = cale.get(Calendar.MINUTE);
        val second = cale.get(Calendar.SECOND);

        versionCode = (year - 2000) * 100000 + month * 1000 + day * 10
        versionName = "" + (year - 2010) + "." + month + "." + day + "." + hour + "." + minute

        //检测mapping folder
        val properties = ConfigProperties(project)
        mappingFolder = properties.getProperty("mapping.dir") ?: ""
    }
}