package com.bingce.flavor;

import java.util.ArrayList;
import java.util.List;

public class FlavorItems {

    public static class FlavorItem {
        public final String name;
        public final String STRING_APP;
        public final int CHANNEL_TYPE;

        public FlavorItem(String name, String string_app, int channel_type) {
            this.name = name;
            STRING_APP = string_app;
            CHANNEL_TYPE = channel_type;
        }
    }

    public static List<FlavorItem> flavorItemList(String configs) {
        List<FlavorItem> flavorItemList = new ArrayList<>();

        String[] contentArray = configs.split("\n");

        String name = "";
        String STRING_APP = "测量员";
        int CHANNEL_TYPE = 0;
        for (String str : contentArray) {
            if (str.startsWith("{")) {
                name = "";
                STRING_APP = "测量员";
                CHANNEL_TYPE = 0;
            } else if (str.startsWith("}")) {
                flavorItemList.add(new FlavorItem(name, STRING_APP, CHANNEL_TYPE));
            } else {
                str = str.trim();
                String[] array = str.split("=");
                if ("name".equals(array[0])) {
                    name = array[1];
                } else if ("STRING_APP".equals(array[0])) {
                    STRING_APP = array[1];
                } else if ("CHANNEL_TYPE".equals(array[0])) {
                    CHANNEL_TYPE = Integer.parseInt(array[1]);
                }
            }
        }

        return flavorItemList;
    }
}
